#ifndef _SPUMACROS_H
#define _SPUMACROS_H 1

#define SPUID spe_info.spuid
#define SPUID_TIMES(n) spe_info.spuid*n

#define SWAP(x, y) {DATATYPE_NO_QUOTES* temp=x; x=y; y=temp;}

/* CHECKSIZE will slow down the execution, and should not be used for timing.
 * Eventually, it should not be used at all since we should be guaranteed that
 * sizes will be DMA-compatible.
 */

/* TODO:
 * The return() should be replaced with something that makes the SPU stop
 * execution. The reason for this is if this macro is called from within a
 * function (like doOddSizeDMA(), then we only return to the SPU, and we don't
 * actually stop execution, which is really what we want.
 */

//          spu_writech(MFC_WrTagMask, -1); \

/*
#define GATHMEM_GET(...)  ((void) 0)
#define SCATMEM_PUT(...)  ((void) 0)
*/

#define GATH_LIST_SETSIZE(pkSize,i) {gathlist[i].size = pkSize * DATATYPE_SIZEINBYTES;}
#define GATH_LIST_SETADDR(func,i,addrBase)   {gathlist[i].eal = mfc_ea2l(addrBase + ((func)*DATATYPE_SIZEINBYTES));}
#define SCAT_LIST_SETSIZE(pkSize,i) {scatlist[i].size = pkSize * DATATYPE_SIZEINBYTES;}
#define SCAT_LIST_SETADDR(func,i,addrBase)   {scatlist[i].eal = mfc_ea2l(addrBase + ((func)*DATATYPE_SIZEINBYTES));}

#define GATHMEM_LIST(lsAddr,eaHigh,listsize) {mfc_getl( (void*)lsAddr, eaHigh, &gathlist, listsize*sizeof(mfc_list_element_t), 2, 0, 0);}
#define SCATMEM_LIST(lsAddr,eaHigh,listsize) {mfc_putl( (void*)lsAddr, eaHigh, &scatlist, listsize*sizeof(mfc_list_element_t), 2, 0, 0);}


/*
#define GATH_LIST_SETSIZE(pkSize,i)             ((void) 0)
#define GATH_LIST_SETADDR(func,i,addrBase)      ((void) 0)
#define SCAT_LIST_SETSIZE(pkSize,i)             ((void) 0)
#define SCAT_LIST_SETADDR(func,i,addrBase)      ((void) 0)

#define GATHMEM_LIST(lsAddr,eaHigh,listsize)    ((void) 0)
#define SCATMEM_LIST(lsAddr,eaHigh,listsize)    ((void) 0)
*/

// Class 3: Twiddles
#define GATHMEM_DIAG(xBase, xOffset, addrBase, addrOffset, size) {\
          spu_mfcdma64(((void *)(xBase)) + (xOffset*DATATYPE_SIZEINBYTES), \
              mfc_ea2h(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              mfc_ea2l(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              size*DATATYPE_SIZEINBYTES, 3, MFC_GET_CMD);}


// Class 2: Multibuffering

#define GATHMEM_GET(xBase, xOffset, addrBase, addrOffset, size) {\
          spu_mfcdma64(((void *)(xBase)) + (xOffset*DATATYPE_SIZEINBYTES), \
              mfc_ea2h(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              mfc_ea2l(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              size*DATATYPE_SIZEINBYTES, 2, MFC_GET_CMD);}

#define SCATMEM_PUT(xBase, xOffset, addrBase, addrOffset, size) {\
          spu_mfcdma64(((void *)(xBase)) + (xOffset*DATATYPE_SIZEINBYTES), \
              mfc_ea2h(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              mfc_ea2l(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              size*DATATYPE_SIZEINBYTES, 2, MFC_PUT_CMD);}


// Class 1: Parallelism

#define SCATSEND_PUT(xBase, xOffset, addrBase, addrOffset, size) {\
          spu_mfcdma64(((void *)(xBase)) + (xOffset*DATATYPE_SIZEINBYTES), \
              mfc_ea2h(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              mfc_ea2l(addrBase+(addrOffset*DATATYPE_SIZEINBYTES)), \
              size*DATATYPE_SIZEINBYTES, 1, MFC_PUT_CMD);}


// Blocking DMA read from mem, size in elements

// #define MEM_GET(xBase, xOffset


// Blocking DMA write to mem, size in elements

// CHECKSIZE: ensures size is DMA'able.
#define CHECKSIZE(size) {\
      if (((size >=16) && (size%16 != 0)) || ((size<16) && (size!=1 && size!=2 && size!=4 && size!=8))) return(size);}

//if (((size >=16) && (size%16 != 0)) || ((size<16) && (size!=1 && size!=2 && size!=4 && size!=8))) debug("SPU: %u size NOT okay!\n", size);}

// Blocking DMA, size in bytes
#define DO_DMA_BL(x, addr, size, DMA_CMD) {\
  CHECKSIZE(size);\
  spu_writech(MFC_WrTagMask, -1); \
  spu_mfcdma64((void *)(x), \
      mfc_ea2h(addr), mfc_ea2l(addr), \
      size, 0, DMA_CMD); \
  spu_mfcstat(MFC_TAG_UPDATE_ALL);}

// Non-blocking DMA, size in bytes
#define DO_DMA(x, addr, size, DMA_CMD) {\
  CHECKSIZE(size);\
  spu_writech(MFC_WrTagMask, -1); \
  spu_mfcdma64((void *)(&x), \
      mfc_ea2h(addr), mfc_ea2l(addr), \
      size, 0, DMA_CMD);}

// Blocking DMA-get, size in bytes
#define DMA_BL_GET_GENERIC(x, addr, size) {\
  DO_DMA(x, addr, size, MFC_GET_CMD) \
  spu_mfcstat(MFC_TAG_UPDATE_ALL);}

// Blocking DMA-put, size in bytes
#define DMA_BL_PUT_GENERIC(x, addr, size) {\
  DO_DMA(x, addr, size, MFC_PUT_CMD) \
  spu_mfcstat(MFC_TAG_UPDATE_ALL);}



  /*
  // Blocking DMA-get, size in #elements
  #define DMA_BL_GET(x, addr, size) {\
    DO_DMA(x, addr, (size*DATATYPE_SIZEINBYTES), MFC_GET_CMD) \
    spu_mfcstat(MFC_TAG_UPDATE_ALL);}
  
  // Blocking DMA-put, size in #elements
  #define DMA_BL_PUT(x, addr, size) {\
    DO_DMA(x, addr, (size*DATATYPE_SIZEINBYTES), MFC_PUT_CMD) \
    spu_mfcstat(MFC_TAG_UPDATE_ALL);}
  
  #define DMA_NBL_PUT(x, addr, size) DO_DMA(x, addr, (size*DATATYPE_SIZEINBYTES), MFC_PUT_CMD)
  
  #define DMA_NBL_PUT_OFFSET(xBase, xOffset, addr, size) \
    DO_DMA(xBase + xOffset, addr, (size*DATATYPE_SIZEINBYTES), MFC_PUT_CMD)
  */

/* Odd sized DMA - does sub-DMAsize DMA when needed. size in bytes
 * - Do everything but the last 15 or less bytes first
 * - Then, we're left with n more bytes to DMA, n=0|4|8|12
 *   (NOTE: This works only if datatype is at least 4 bytes!)
 * - Handle each of these cases separately
 */

#define doOddSizeDMA(x, addr, size, DMA_CMD) { \
  if (size >=16) DO_DMA_BL(x, addr, (size - (size % 16)), DMA_CMD); \
  switch (size % 16) { \
    case 0:     break; \
    case 4:     DO_DMA_BL(x + ((size-(size%16))/DATATYPE_SIZEINBYTES), (addr + (size - (size % 16))), 4, DMA_CMD); break; \
    case 8:     DO_DMA_BL(x + ((size-(size%16))/DATATYPE_SIZEINBYTES), (addr + (size - (size % 16))), 8, DMA_CMD); break; \
    case 12:    DO_DMA_BL(x + ((size-(size%16))/DATATYPE_SIZEINBYTES), (addr + (size - (size % 16))), 8, DMA_CMD); \
                DO_DMA_BL(x + ((size-(size%16))/DATATYPE_SIZEINBYTES), (addr + (size - (size % 16)) + 8), 4, DMA_CMD); \
                break; \
    default: \
      debug1("SPU: Quit giving me weird sizes to DMA!\n"); \
  } \
}

// Odd sized DMA-get, put. size in #elements
//#define DMA_ODD_BL_GET(x, addr, size) doOddSizeDMA(x, addr, (size*DATATYPE_SIZEINBYTES), MFC_GET_CMD)
//#define DMA_ODD_BL_PUT(x, addr, size) doOddSizeDMA(x, addr, (size*DATATYPE_SIZEINBYTES), MFC_PUT_CMD)

#define DMA_ODD_BL_GET(x, addr, size) doOddSizeDMA(x, addr, size, MFC_GET_CMD)
#define DMA_ODD_BL_PUT(x, addr, size) doOddSizeDMA(x, addr, size, MFC_PUT_CMD)

// Works (for testing only. size is incorrect).
// #define DMA_ODD_BL_GET(x, addr, size) DMA_BL_GET(x, addr, size)
// #define DMA_ODD_BL_PUT(x, addr, size) DMA_BL_PUT(x, addr, size)

#define BLOCK_ON_WRITE_COMPLETE  {spu_writech(MFC_WrTagMask, 1 << 1); spu_mfcstat(MFC_TAG_UPDATE_ALL);}
#define BLOCK_ON_DIAG            {spu_writech(MFC_WrTagMask, 1 << 3); spu_mfcstat(MFC_TAG_UPDATE_ALL);}

#define ADDR(spuNum, offset) (unsigned long long) spe_info.spu_ls[spuNum] + (unsigned long long) offset
// #define ADDR_OFFSET(spuNum, xBase, xOffset) (unsigned long long) spe_info.spu_ls[spuNum] + (unsigned long long) (xBase + xOffset)

//#define OLD_BARRIER {BLOCK_ON_WRITE_COMPLETE; NOTIFY_ALL_WRITE}
#define ALL_TO_ALL_BARRIER {BLOCK_ON_WRITE_COMPLETE; sig_barrier();}




/* ---------------------------------------------------------------------------
 * Old Barrier
 * ---------------------------------------------------------------------------
 */

/*
void BLOCK_ON_READ() {
  unsigned int recvSignal=0, newSig=0;
  while (recvSignal != spuRecvSigValue) {
    debug("SPU[%u]: Waiting on signal %x. Current value: %x\n", spe_info.spuid, spuRecvSigValue, recvSignal);
    newSig = spu_read_signal1();
#ifdef DEBUG
    assert((recvSignal | newSig) != recvSignal);
#endif
    recvSignal |= newSig;
  }

#define WRITE_NOTIFY(spuNum) {\
  mfc_sndsig( ((char*) (&writeSignal) + 12), \
      (spe_info.spu_ps[spuNum]+12), \
      0, 0, 0);}

#define NOTIFY_ALL_WRITE {\
  for (unsigned int i=0; i<SPUS; i++) \
    if (i != spe_info.spuid) { \
      WRITE_NOTIFY(i); \
      debug("SPU[%u]: Notifying partner %d. Writesignal is ---> %d\n", spe_info.spuid, i, writeSignal[3]); \
    } \
}
}
*/


//  debug("SPU[%d]: Read signal %u. spuRecvSigValue is %x\n", spe_info.spuid, testSignal, spuRecvSigValue);

  /*
   * What this really has to do is to wait for all SPUs to send a write
   * complete signal. In SIGNOTOFY1_OR mode, this means that every SPU has to
   * write one bit into this SPU. So we could keep reading the register until
   * the value we got was all 1's (# of 1s = #of spus) with the exception that
   * our SPU's one wouldn't be there. So do this using a mask.
   *
   * The one issue to watch out for: SPUs signalling us more than once in the
   * same cycle. This should be rare, but possible, especially in the first
   * block. The problem is, checking for this condition is expensive.
   *
   * In the signal checking loop, we could read each time and check to ensure
   * each time that we didn't re-read any of the previous bits. This is a) a
   * bit expensive. b) doesn't really solve the problem of what happens if an
   * SPU is written a bit twice even before we read it the first time.
   */

#endif
