/***************************************************************
This code was generated by  Spiral 5.0 beta, www.spiral.net --
Copyright (c) 2005, Carnegie Mellon University
All rights reserved.
The code is distributed under a BSD style license
(see http://www.opensource.org/licenses/bsd-license.php)

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

* Redistributions of source code must retain the above copyright
  notice, reference to Spiral, this list of conditions and the
  following disclaimer.
* Redistributions in binary form must reproduce the above
  copyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials provided
  with the distribution.
* Neither the name of Carnegie Mellon University nor the name of its
  contributors may be used to endorse or promote products derived from
  this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
*AS IS* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
******************************************************************/

#ifndef OMEGA_32_H_INCLUDED
#define OMEGA_32_H_INCLUDED 1
#include <math.h>
#include <stdlib.h>

#define PI    3.14159265358979323846f

typedef struct { float r,i; } complex_t;

/*
static complex_t COMPLEX(float r, float i) { 
   complex_t cplx; 
   cplx.r = r; 
   cplx.i = i; 
   return cplx; 
}
*/

static complex_t omega(int N, int k) { 
   complex_t w; 
   w.r = cos(2*PI*k/N); w.i = sin(2*PI*k/N); return w; 
}

static float cospi(float a) { return cos(PI*a); }

static float sinpi(float a) { return sin(PI*a); }

static int powmod(int phi, int g, int exp, int N) {
    int retVal, i;
    retVal = phi % N;
    for (i=0; i<exp; i++) retVal = (retVal * g) % N;
    return(retVal);
}

static double fr(int m, int i, double r) {
  if((i % 2)==0) 
    return (r + 2*((int)i/2)) / m;
  else 
    return (2 - r + 2*((int)i/2)) / m;
}

#define RE_CPX(x) ((x).r)
#define IM_CPX(x) ((x).i)
#define CPX complex_t

#define RE_FLT(a) (a)
#define IM_FLT(a) (0.0)
#define RE_INT(a) (a)
#define IM_INT(a) (0)

#endif

