/*************************************************************************
 * This code was generated by Spiral 6.0 beta, www.spiral.net --
 * Copyright (c) 2005-2008, Carnegie Mellon University.
 * All rights reserved.
 * The code is distributed under the GNU General Public License (GPL)
 * (see http://www.gnu.org/copyleft/gpl.html)

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * *AS IS* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *************************************************************************/





#include <spu_mfcio.h>

extern spe_infostruct spe_info;



#include "spumacros.h"






#include <math.h>
#include <spu_intrinsics.h>
#include <omega32.h>
static __attribute__((aligned(16))) vector float D1[512];
static __attribute__((aligned(16))) vector float D2[1024];

void init_spu_dft() {
    for(int i15 = 0; i15 <= 15; i15++) {
        for(int i22 = 0; i22 <= 3; i22++) {
            for(int i34 = 0; i34 <= 1; i34++) {
                D1[((i15 * 32) + ((i22 * 8) + (i34 * 4)))] = spu_splats((float)cospi((((float)(2 * (i15 * ((4 * i34) + i22)))) / 256)));
                D1[((i15 * 32) + ((i22 * 8) + ((i34 * 4) + 1)))] = spu_splats((float)sinpi((((float)(2 * (i15 * ((4 * i34) + i22)))) / 256)));
                D1[((i15 * 32) + ((i22 * 8) + ((i34 * 4) + 2)))] = spu_splats((float)cospi((((float)(2 * (i15 * (8 + ((4 * i34) + i22))))) / 256)));
                D1[((i15 * 32) + ((i22 * 8) + ((i34 * 4) + 3)))] = spu_splats((float)sinpi((((float)(2 * (i15 * (8 + ((4 * i34) + i22))))) / 256)));
            }
        }
    }
    for(int i4 = 0; i4 <= 1; i4++) {
        for(int i15 = 0; i15 <= 15; i15++) {
            for(int i23 = 0; i23 <= 3; i23++) {
                for(int i39 = 0; i39 <= 1; i39++) {
                    D2[((i4 * 512) + ((i15 * 32) + ((i23 * 8) + (i39 * 4))))] = (vector float){cospi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * (4 * i4)))) / 2048)), cospi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * ((4 * i4) + 1)))) / 2048)), cospi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * ((4 * i4) + 2)))) / 2048)), cospi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * ((4 * i4) + 3)))) / 2048))};
                    D2[((i4 * 512) + ((i15 * 32) + ((i23 * 8) + ((i39 * 4) + 1))))] = (vector float){sinpi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * (4 * i4)))) / 2048)), sinpi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * ((4 * i4) + 1)))) / 2048)), sinpi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * ((4 * i4) + 2)))) / 2048)), sinpi((((float)(2 * (((64 * i39) + ((16 * i23) + i15)) * ((4 * i4) + 3)))) / 2048))};
                    D2[((i4 * 512) + ((i15 * 32) + ((i23 * 8) + ((i39 * 4) + 2))))] = (vector float){cospi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * (4 * i4)))) / 2048)), cospi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * ((4 * i4) + 1)))) / 2048)), cospi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * ((4 * i4) + 2)))) / 2048)), cospi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * ((4 * i4) + 3)))) / 2048))};
                    D2[((i4 * 512) + ((i15 * 32) + ((i23 * 8) + ((i39 * 4) + 3))))] = (vector float){sinpi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * (4 * i4)))) / 2048)), sinpi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * ((4 * i4) + 1)))) / 2048)), sinpi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * ((4 * i4) + 2)))) / 2048)), sinpi((((float)(2 * ((128 + ((64 * i39) + ((16 * i23) + i15))) * ((4 * i4) + 3)))) / 2048))};
                }
            }
        }
    }
}

void spu_dft(float  *Y, float  *X) {
    static __attribute__((aligned(16))) float T1[4096];
    for(int i1 = 0; i1 <= 63; i1++) {
        vector float  *a147, *a148;
        vector float s140, s141, s142, s143, s144, s145, s146
    , s147, s148, s149, s150, s151, s152, s153, s154
    , s155, s156, s157, s158, s159, s160, s161, s162
    , s163, s164, s165, s166, s167, s168, s169, s170
    , s171, s172, s173, s174, s175, s176, s177, s178
    , s179, s180, s181, s182, s183, s184, s185, s186
    , s187, s188, s189, s190, s191, s192, s193, s194
    , s195, s196, s197, s198, s199, s200, s201, s202
    , s203, s204, s205, s206, s207, t185, t186, t187
    , t188, t189, t190, t191, t192, t193, t194, t195
    , t196, t197, t198, t199, t200, t201, t202, t203
    , t204, t205, t206, t207, t208, t209, t210, t211
    , t212, t213, t214, t215, t216, t217, t218, t219
    , t220, t221, t222, t223, t224, t225, t226, t227
    , t228, t229, t230, t231, t232;
        a147 = (((vector float  *) X) + (2 * i1));
        s140 = *(a147);
        s141 = *((a147 + 1));
        s142 = spu_shuffle(s140, s141, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s143 = spu_shuffle(s140, s141, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        s144 = *((a147 + 512));
        s145 = *((a147 + 513));
        s146 = spu_shuffle(s144, s145, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s147 = spu_shuffle(s144, s145, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        t185 = spu_add(s142, s146);
        t186 = spu_add(s143, s147);
        t187 = spu_sub(s142, s146);
        t188 = spu_sub(s143, s147);
        s148 = *((a147 + 256));
        s149 = *((a147 + 257));
        s150 = spu_shuffle(s148, s149, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s151 = spu_shuffle(s148, s149, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        s152 = *((a147 + 768));
        s153 = *((a147 + 769));
        s154 = spu_shuffle(s152, s153, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s155 = spu_shuffle(s152, s153, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        t189 = spu_add(s150, s154);
        t190 = spu_add(s151, s155);
        t191 = spu_sub(s150, s154);
        t192 = spu_sub(s151, s155);
        t193 = spu_add(t185, t189);
        t194 = spu_add(t186, t190);
        t195 = spu_sub(t185, t189);
        t196 = spu_sub(t186, t190);
        t197 = spu_sub(t187, t192);
        t198 = spu_add(t188, t191);
        t199 = spu_add(t187, t192);
        t200 = spu_sub(t188, t191);
        s156 = *((a147 + 128));
        s157 = *((a147 + 129));
        s158 = spu_shuffle(s156, s157, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s159 = spu_shuffle(s156, s157, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        s160 = *((a147 + 640));
        s161 = *((a147 + 641));
        s162 = spu_shuffle(s160, s161, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s163 = spu_shuffle(s160, s161, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        t201 = spu_add(s158, s162);
        t202 = spu_add(s159, s163);
        t203 = spu_sub(s158, s162);
        t204 = spu_sub(s159, s163);
        s164 = *((a147 + 384));
        s165 = *((a147 + 385));
        s166 = spu_shuffle(s164, s165, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s167 = spu_shuffle(s164, s165, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        s168 = *((a147 + 896));
        s169 = *((a147 + 897));
        s170 = spu_shuffle(s168, s169, ((vector unsigned char){0, 1, 2, 3, 8, 9, 10, 11, 16, 17, 18, 19, 24, 25, 26, 27}));
        s171 = spu_shuffle(s168, s169, ((vector unsigned char){4, 5, 6, 7, 12, 13, 14, 15, 20, 21, 22, 23, 28, 29, 30, 31}));
        t205 = spu_add(s166, s170);
        t206 = spu_add(s167, s171);
        t207 = spu_sub(s166, s170);
        t208 = spu_sub(s167, s171);
        t209 = spu_add(t201, t205);
        t210 = spu_add(t202, t206);
        t211 = spu_sub(t201, t205);
        t212 = spu_sub(t202, t206);
        t213 = spu_sub(t203, t208);
        t214 = spu_add(t204, t207);
        t215 = spu_add(t203, t208);
        t216 = spu_sub(t204, t207);
        s172 = spu_sub(t213, t214);
        s173 = spu_add(t213, t214);
        s174 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), t216, t215);
        s175 = spu_add(spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), t215, ((vector float){0,0,0,0})), spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), t216, ((vector float){0,0,0,0})));
        t217 = spu_add(t193, t209);
        t218 = spu_add(t194, t210);
        t219 = spu_sub(t193, t209);
        t220 = spu_sub(t194, t210);
        t221 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s172, t197);
        t222 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s173, t198);
        t223 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s172, t197);
        t224 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s173, t198);
        t225 = spu_sub(t195, t212);
        t226 = spu_add(t196, t211);
        t227 = spu_add(t195, t212);
        t228 = spu_sub(t196, t211);
        t229 = spu_madd(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s174, t199);
        t230 = spu_add(t200, s175);
        t231 = spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s174, t199);
        t232 = spu_sub(t200, s175);
        s176 = spu_shuffle(t217, t221, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s177 = spu_shuffle(t217, t221, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s178 = spu_shuffle(t218, t222, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s179 = spu_shuffle(t218, t222, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s180 = spu_shuffle(t225, t229, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s181 = spu_shuffle(t225, t229, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s182 = spu_shuffle(t226, t230, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s183 = spu_shuffle(t226, t230, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        a148 = (((vector float  *) T1) + (16 * i1));
        s184 = spu_shuffle(s176, s180, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *(a148) = s184;
        s185 = spu_shuffle(s176, s180, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 4)) = s185;
        s186 = spu_shuffle(s177, s181, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a148 + 8)) = s186;
        s187 = spu_shuffle(s177, s181, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 12)) = s187;
        s188 = spu_shuffle(s178, s182, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a148 + 1)) = s188;
        s189 = spu_shuffle(s178, s182, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 5)) = s189;
        s190 = spu_shuffle(s179, s183, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a148 + 9)) = s190;
        s191 = spu_shuffle(s179, s183, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 13)) = s191;
        s192 = spu_shuffle(t219, t223, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s193 = spu_shuffle(t219, t223, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s194 = spu_shuffle(t220, t224, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s195 = spu_shuffle(t220, t224, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s196 = spu_shuffle(t227, t231, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s197 = spu_shuffle(t227, t231, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s198 = spu_shuffle(t228, t232, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s199 = spu_shuffle(t228, t232, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s200 = spu_shuffle(s192, s196, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a148 + 2)) = s200;
        s201 = spu_shuffle(s192, s196, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 6)) = s201;
        s202 = spu_shuffle(s193, s197, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a148 + 10)) = s202;
        s203 = spu_shuffle(s193, s197, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 14)) = s203;
        s204 = spu_shuffle(s194, s198, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a148 + 3)) = s204;
        s205 = spu_shuffle(s194, s198, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 7)) = s205;
        s206 = spu_shuffle(s195, s199, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a148 + 11)) = s206;
        s207 = spu_shuffle(s195, s199, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a148 + 15)) = s207;
    }
    for(int i4 = 0; i4 <= 1; i4++) {
        static __attribute__((aligned(16))) float T26[2048];
        for(int i15 = 0; i15 <= 15; i15++) {
            int a1337;
            vector float  *a1336, *a1338, *a1371, *a1376;
            vector float a1339, a1340, a1341, a1342, a1343, a1344, a1345
    , a1346, a1347, a1348, a1349, a1350, a1351, a1352, a1353
    , a1354, a1355, a1356, a1357, a1358, a1359, a1360, a1361
    , a1362, a1363, a1364, a1365, a1366, a1367, a1368, a1369
    , a1370, a1372, a1373, a1374, a1375, a1377, a1378, a1379
    , a1380, a1381, a1382, a1383, a1384, a1385, a1386, a1387
    , a1388, a1389, a1390, a1391, a1392, a1393, a1394, a1395
    , a1396, a1397, a1398, a1399, a1400, a1401, a1402, a1403
    , a1404, s457, s458, s459, s460, s461, s462, s463
    , s464, s465, s466, s467, s468, s469, s470, s471
    , s472, s473, s474, s475, s476, s477, s478, s479
    , s480, s481, s482, s483, s484, s485, s486, s487
    , s488, s489, s490, s491, s492, s493, s494, s495
    , s496, s497, s498, s499, s500, s501, s502, s503
    , s504, s505, s506, s507, s508, s509, s510, s511
    , s512, s513, s514, s515, s516, s517, s518, s519
    , s520, s521, s522, s523, s524, s525, s526, s527
    , s528, s529, s530, s531, s532, s533, s534, s535
    , s536, s537, s538, s539, s540, s541, s542, s543
    , s544, s545, s546, s547, s548, s549, s550, s551
    , s552, s553, s554, s555, s556, s557, s558, s559
    , s560, s561, s562, s563, s564, s565, s566, s567
    , s568, s569, s570, s571, s572, s573, s574, s575
    , s576, s577, s578, t490, t491, t492, t493, t494
    , t495, t496, t497, t498, t499, t500, t501, t502
    , t503, t504, t505, t506, t507, t508, t509, t510
    , t511, t512, t513, t514, t515, t516, t517, t518
    , t519, t520, t521, t522, t523, t524, t525, t526
    , t527, t528, t529, t530, t531, t532, t533, t534
    , t535, t536, t537, t538, t539, t540, t541, t542
    , t543, t544, t545, t546, t547, t548, t549, t550
    , t551, t552, t553, t554, t555, t556, t557, t558
    , t559, t560, t561, t562, t563, t564, t565, t566
    , t567, t568, t569, t570, t571, t572, t573, t574
    , t575, t576, t577, t578, t579, t580, t581, t582
    , t583, t584, t585, t586, t587, t588, t589, t590
    , t591, t592, t593, t594, t595, t596, t597, t598
    , t599, t600, t601, t602, t603, t604, t605, t606
    , t607;
            a1336 = (((vector float  *) T1) + ((2 * i4) + (4 * i15)));
            s457 = *(a1336);
            s458 = *((a1336 + 1));
            s459 = *((a1336 + 512));
            s460 = *((a1336 + 513));
            a1337 = (32 * i15);
            a1338 = (D2 + ((512 * i4) + a1337));
            a1339 = *(a1338);
            a1340 = *((a1338 + 1));
            s461 = spu_sub(spu_mul(a1339, s457), spu_mul(a1340, s458));
            s462 = spu_add(spu_mul(a1340, s457), spu_mul(a1339, s458));
            a1341 = *((a1338 + 2));
            a1342 = *((a1338 + 3));
            s463 = spu_sub(spu_mul(a1341, s459), spu_mul(a1342, s460));
            s464 = spu_add(spu_mul(a1342, s459), spu_mul(a1341, s460));
            t490 = spu_add(s461, s463);
            t491 = spu_add(s462, s464);
            t492 = spu_sub(s461, s463);
            t493 = spu_sub(s462, s464);
            s465 = *((a1336 + 256));
            s466 = *((a1336 + 257));
            s467 = *((a1336 + 768));
            s468 = *((a1336 + 769));
            a1343 = *((a1338 + 4));
            a1344 = *((a1338 + 5));
            s469 = spu_sub(spu_mul(a1343, s465), spu_mul(a1344, s466));
            s470 = spu_add(spu_mul(a1344, s465), spu_mul(a1343, s466));
            a1345 = *((a1338 + 6));
            a1346 = *((a1338 + 7));
            s471 = spu_sub(spu_mul(a1345, s467), spu_mul(a1346, s468));
            s472 = spu_add(spu_mul(a1346, s467), spu_mul(a1345, s468));
            t494 = spu_add(s469, s471);
            t495 = spu_add(s470, s472);
            t496 = spu_sub(s469, s471);
            t497 = spu_sub(s470, s472);
            t498 = spu_add(t490, t494);
            t499 = spu_add(t491, t495);
            t500 = spu_sub(t490, t494);
            t501 = spu_sub(t491, t495);
            t502 = spu_sub(t492, t497);
            t503 = spu_add(t493, t496);
            t504 = spu_add(t492, t497);
            t505 = spu_sub(t493, t496);
            s473 = *((a1336 + 64));
            s474 = *((a1336 + 65));
            s475 = *((a1336 + 576));
            s476 = *((a1336 + 577));
            a1347 = *((a1338 + 8));
            a1348 = *((a1338 + 9));
            s477 = spu_sub(spu_mul(a1347, s473), spu_mul(a1348, s474));
            s478 = spu_add(spu_mul(a1348, s473), spu_mul(a1347, s474));
            a1349 = *((a1338 + 10));
            a1350 = *((a1338 + 11));
            s479 = spu_sub(spu_mul(a1349, s475), spu_mul(a1350, s476));
            s480 = spu_add(spu_mul(a1350, s475), spu_mul(a1349, s476));
            t506 = spu_add(s477, s479);
            t507 = spu_add(s478, s480);
            t508 = spu_sub(s477, s479);
            t509 = spu_sub(s478, s480);
            s481 = *((a1336 + 320));
            s482 = *((a1336 + 321));
            s483 = *((a1336 + 832));
            s484 = *((a1336 + 833));
            a1351 = *((a1338 + 12));
            a1352 = *((a1338 + 13));
            s485 = spu_sub(spu_mul(a1351, s481), spu_mul(a1352, s482));
            s486 = spu_add(spu_mul(a1352, s481), spu_mul(a1351, s482));
            a1353 = *((a1338 + 14));
            a1354 = *((a1338 + 15));
            s487 = spu_sub(spu_mul(a1353, s483), spu_mul(a1354, s484));
            s488 = spu_add(spu_mul(a1354, s483), spu_mul(a1353, s484));
            t510 = spu_add(s485, s487);
            t511 = spu_add(s486, s488);
            t512 = spu_sub(s485, s487);
            t513 = spu_sub(s486, s488);
            t514 = spu_add(t506, t510);
            t515 = spu_add(t507, t511);
            t516 = spu_sub(t506, t510);
            t517 = spu_sub(t507, t511);
            s489 = spu_sub(t516, t517);
            s490 = spu_add(t516, t517);
            t518 = spu_sub(t508, t513);
            t519 = spu_add(t509, t512);
            t520 = spu_add(t508, t513);
            t521 = spu_sub(t509, t512);
            s491 = spu_nmsub(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t519, t518);
            s492 = spu_madd(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t519, t518);
            s493 = spu_nmsub(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t521, t520);
            s494 = spu_madd(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t521, t520);
            s495 = *((a1336 + 128));
            s496 = *((a1336 + 129));
            s497 = *((a1336 + 640));
            s498 = *((a1336 + 641));
            a1355 = *((a1338 + 16));
            a1356 = *((a1338 + 17));
            s499 = spu_sub(spu_mul(a1355, s495), spu_mul(a1356, s496));
            s500 = spu_add(spu_mul(a1356, s495), spu_mul(a1355, s496));
            a1357 = *((a1338 + 18));
            a1358 = *((a1338 + 19));
            s501 = spu_sub(spu_mul(a1357, s497), spu_mul(a1358, s498));
            s502 = spu_add(spu_mul(a1358, s497), spu_mul(a1357, s498));
            t522 = spu_add(s499, s501);
            t523 = spu_add(s500, s502);
            t524 = spu_sub(s499, s501);
            t525 = spu_sub(s500, s502);
            s503 = *((a1336 + 384));
            s504 = *((a1336 + 385));
            s505 = *((a1336 + 896));
            s506 = *((a1336 + 897));
            a1359 = *((a1338 + 20));
            a1360 = *((a1338 + 21));
            s507 = spu_sub(spu_mul(a1359, s503), spu_mul(a1360, s504));
            s508 = spu_add(spu_mul(a1360, s503), spu_mul(a1359, s504));
            a1361 = *((a1338 + 22));
            a1362 = *((a1338 + 23));
            s509 = spu_sub(spu_mul(a1361, s505), spu_mul(a1362, s506));
            s510 = spu_add(spu_mul(a1362, s505), spu_mul(a1361, s506));
            t526 = spu_add(s507, s509);
            t527 = spu_add(s508, s510);
            t528 = spu_sub(s507, s509);
            t529 = spu_sub(s508, s510);
            t530 = spu_add(t522, t526);
            t531 = spu_add(t523, t527);
            t532 = spu_sub(t522, t526);
            t533 = spu_sub(t523, t527);
            t534 = spu_sub(t524, t529);
            t535 = spu_add(t525, t528);
            t536 = spu_add(t524, t529);
            t537 = spu_sub(t525, t528);
            s511 = spu_sub(t534, t535);
            s512 = spu_add(t534, t535);
            s513 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), t537, t536);
            s514 = spu_add(spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), t536, ((vector float){0,0,0,0})), spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), t537, ((vector float){0,0,0,0})));
            s515 = *((a1336 + 192));
            s516 = *((a1336 + 193));
            s517 = *((a1336 + 704));
            s518 = *((a1336 + 705));
            a1363 = *((a1338 + 24));
            a1364 = *((a1338 + 25));
            s519 = spu_sub(spu_mul(a1363, s515), spu_mul(a1364, s516));
            s520 = spu_add(spu_mul(a1364, s515), spu_mul(a1363, s516));
            a1365 = *((a1338 + 26));
            a1366 = *((a1338 + 27));
            s521 = spu_sub(spu_mul(a1365, s517), spu_mul(a1366, s518));
            s522 = spu_add(spu_mul(a1366, s517), spu_mul(a1365, s518));
            t538 = spu_add(s519, s521);
            t539 = spu_add(s520, s522);
            t540 = spu_sub(s519, s521);
            t541 = spu_sub(s520, s522);
            s523 = *((a1336 + 448));
            s524 = *((a1336 + 449));
            s525 = *((a1336 + 960));
            s526 = *((a1336 + 961));
            a1367 = *((a1338 + 28));
            a1368 = *((a1338 + 29));
            s527 = spu_sub(spu_mul(a1367, s523), spu_mul(a1368, s524));
            s528 = spu_add(spu_mul(a1368, s523), spu_mul(a1367, s524));
            a1369 = *((a1338 + 30));
            a1370 = *((a1338 + 31));
            s529 = spu_sub(spu_mul(a1369, s525), spu_mul(a1370, s526));
            s530 = spu_add(spu_mul(a1370, s525), spu_mul(a1369, s526));
            t542 = spu_add(s527, s529);
            t543 = spu_add(s528, s530);
            t544 = spu_sub(s527, s529);
            t545 = spu_sub(s528, s530);
            t546 = spu_add(t538, t542);
            t547 = spu_add(t539, t543);
            t548 = spu_sub(t538, t542);
            t549 = spu_sub(t539, t543);
            s531 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), t549, t548);
            s532 = spu_add(spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), t548, ((vector float){0,0,0,0})), spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), t549, ((vector float){0,0,0,0})));
            t550 = spu_sub(t540, t545);
            t551 = spu_add(t541, t544);
            t552 = spu_add(t540, t545);
            t553 = spu_sub(t541, t544);
            s533 = spu_nmsub(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t551, t550);
            s534 = spu_madd(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t551, t550);
            s535 = spu_nmsub(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t553, t552);
            s536 = spu_madd(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t553, t552);
            t554 = spu_add(t498, t530);
            t555 = spu_add(t499, t531);
            t556 = spu_sub(t498, t530);
            t557 = spu_sub(t499, t531);
            t558 = spu_add(t514, t546);
            t559 = spu_add(t515, t547);
            t560 = spu_sub(t514, t546);
            t561 = spu_sub(t515, t547);
            t562 = spu_add(t554, t558);
            t563 = spu_add(t555, t559);
            t564 = spu_sub(t554, t558);
            t565 = spu_sub(t555, t559);
            a1371 = (D1 + a1337);
            a1372 = *(a1371);
            a1373 = *((a1371 + 1));
            a1374 = *((a1371 + 2));
            a1375 = *((a1371 + 3));
            a1376 = (((vector float  *) T26) + a1337);
            s537 = spu_sub(spu_mul(a1372, t562), spu_mul(a1373, t563));
            *(a1376) = s537;
            s538 = spu_add(spu_mul(a1373, t562), spu_mul(a1372, t563));
            *((a1376 + 1)) = s538;
            s539 = spu_sub(spu_mul(a1374, t564), spu_mul(a1375, t565));
            *((a1376 + 16)) = s539;
            s540 = spu_add(spu_mul(a1375, t564), spu_mul(a1374, t565));
            *((a1376 + 17)) = s540;
            t566 = spu_sub(t556, t561);
            t567 = spu_add(t557, t560);
            t568 = spu_add(t556, t561);
            t569 = spu_sub(t557, t560);
            a1377 = *((a1371 + 4));
            a1378 = *((a1371 + 5));
            a1379 = *((a1371 + 6));
            a1380 = *((a1371 + 7));
            s541 = spu_sub(spu_mul(a1377, t566), spu_mul(a1378, t567));
            *((a1376 + 8)) = s541;
            s542 = spu_add(spu_mul(a1378, t566), spu_mul(a1377, t567));
            *((a1376 + 9)) = s542;
            s543 = spu_sub(spu_mul(a1379, t568), spu_mul(a1380, t569));
            *((a1376 + 24)) = s543;
            s544 = spu_add(spu_mul(a1380, t568), spu_mul(a1379, t569));
            *((a1376 + 25)) = s544;
            t570 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s511, t502);
            t571 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s512, t503);
            t572 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s511, t502);
            t573 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s512, t503);
            s545 = spu_madd(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), s533, s491);
            s546 = spu_madd(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), s534, s492);
            s547 = spu_nmsub(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), s533, s491);
            s548 = spu_nmsub(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), s534, s492);
            t574 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s545, t570);
            t575 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s546, t571);
            t576 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s545, t570);
            t577 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s546, t571);
            a1381 = *((a1371 + 8));
            a1382 = *((a1371 + 9));
            a1383 = *((a1371 + 10));
            a1384 = *((a1371 + 11));
            s549 = spu_sub(spu_mul(a1381, t574), spu_mul(a1382, t575));
            *((a1376 + 2)) = s549;
            s550 = spu_add(spu_mul(a1382, t574), spu_mul(a1381, t575));
            *((a1376 + 3)) = s550;
            s551 = spu_sub(spu_mul(a1383, t576), spu_mul(a1384, t577));
            *((a1376 + 18)) = s551;
            s552 = spu_add(spu_mul(a1384, t576), spu_mul(a1383, t577));
            *((a1376 + 19)) = s552;
            t578 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s548, t572);
            t579 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s547, t573);
            t580 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s548, t572);
            t581 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s547, t573);
            a1385 = *((a1371 + 12));
            a1386 = *((a1371 + 13));
            a1387 = *((a1371 + 14));
            a1388 = *((a1371 + 15));
            s553 = spu_sub(spu_mul(a1385, t578), spu_mul(a1386, t579));
            *((a1376 + 10)) = s553;
            s554 = spu_add(spu_mul(a1386, t578), spu_mul(a1385, t579));
            *((a1376 + 11)) = s554;
            s555 = spu_sub(spu_mul(a1387, t580), spu_mul(a1388, t581));
            *((a1376 + 26)) = s555;
            s556 = spu_add(spu_mul(a1388, t580), spu_mul(a1387, t581));
            *((a1376 + 27)) = s556;
            t582 = spu_sub(t500, t533);
            t583 = spu_add(t501, t532);
            t584 = spu_add(t500, t533);
            t585 = spu_sub(t501, t532);
            s557 = spu_madd(((vector float){(-1), (-1), (-1), (-1)}), s531, s489);
            t586 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s490, s532);
            s558 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), s531, s489);
            t587 = spu_msub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s490, s532);
            t588 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s557, t582);
            t589 = spu_add(t583, t586);
            t590 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s557, t582);
            t591 = spu_sub(t583, t586);
            a1389 = *((a1371 + 16));
            a1390 = *((a1371 + 17));
            a1391 = *((a1371 + 18));
            a1392 = *((a1371 + 19));
            s559 = spu_sub(spu_mul(a1389, t588), spu_mul(a1390, t589));
            *((a1376 + 4)) = s559;
            s560 = spu_add(spu_mul(a1390, t588), spu_mul(a1389, t589));
            *((a1376 + 5)) = s560;
            s561 = spu_sub(spu_mul(a1391, t590), spu_mul(a1392, t591));
            *((a1376 + 20)) = s561;
            s562 = spu_add(spu_mul(a1392, t590), spu_mul(a1391, t591));
            *((a1376 + 21)) = s562;
            t592 = spu_sub(t584, t587);
            t593 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s558, t585);
            t594 = spu_add(t584, t587);
            t595 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s558, t585);
            a1393 = *((a1371 + 20));
            a1394 = *((a1371 + 21));
            a1395 = *((a1371 + 22));
            a1396 = *((a1371 + 23));
            s563 = spu_sub(spu_mul(a1393, t592), spu_mul(a1394, t593));
            *((a1376 + 12)) = s563;
            s564 = spu_add(spu_mul(a1394, t592), spu_mul(a1393, t593));
            *((a1376 + 13)) = s564;
            s565 = spu_sub(spu_mul(a1395, t594), spu_mul(a1396, t595));
            *((a1376 + 28)) = s565;
            s566 = spu_add(spu_mul(a1396, t594), spu_mul(a1395, t595));
            *((a1376 + 29)) = s566;
            t596 = spu_madd(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s513, t504);
            t597 = spu_add(t505, s514);
            t598 = spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s513, t504);
            t599 = spu_sub(t505, s514);
            s567 = spu_madd(((vector float){(-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949)}), s535, s493);
            s568 = spu_madd(((vector float){(-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509)}), s536, s494);
            s569 = spu_nmsub(((vector float){(-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949)}), s535, s493);
            s570 = spu_nmsub(((vector float){(-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509)}), s536, s494);
            t600 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s567, t596);
            t601 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s568, t597);
            t602 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s567, t596);
            t603 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s568, t597);
            a1397 = *((a1371 + 24));
            a1398 = *((a1371 + 25));
            a1399 = *((a1371 + 26));
            a1400 = *((a1371 + 27));
            s571 = spu_sub(spu_mul(a1397, t600), spu_mul(a1398, t601));
            *((a1376 + 6)) = s571;
            s572 = spu_add(spu_mul(a1398, t600), spu_mul(a1397, t601));
            *((a1376 + 7)) = s572;
            s573 = spu_sub(spu_mul(a1399, t602), spu_mul(a1400, t603));
            *((a1376 + 22)) = s573;
            s574 = spu_add(spu_mul(a1400, t602), spu_mul(a1399, t603));
            *((a1376 + 23)) = s574;
            t604 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s570, t598);
            t605 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s569, t599);
            t606 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s570, t598);
            t607 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s569, t599);
            a1401 = *((a1371 + 28));
            a1402 = *((a1371 + 29));
            a1403 = *((a1371 + 30));
            a1404 = *((a1371 + 31));
            s575 = spu_sub(spu_mul(a1401, t604), spu_mul(a1402, t605));
            *((a1376 + 14)) = s575;
            s576 = spu_add(spu_mul(a1402, t604), spu_mul(a1401, t605));
            *((a1376 + 15)) = s576;
            s577 = spu_sub(spu_mul(a1403, t606), spu_mul(a1404, t607));
            *((a1376 + 30)) = s577;
            s578 = spu_add(spu_mul(a1404, t606), spu_mul(a1403, t607));
            *((a1376 + 31)) = s578;
        }
        for(int i14 = 0; i14 <= 15; i14++) {
            vector float  *a1758, *a1759;
            vector float s763, s764, s765, s766, s767, s768, s769
    , s770, s771, s772, s773, s774, s775, s776, s777
    , s778, s779, s780, s781, s782, s783, s784, s785
    , s786, s787, s788, s789, s790, s791, s792, s793
    , s794, s795, s796, s797, s798, s799, s800, s801
    , s802, s803, s804, s805, s806, s807, s808, s809
    , s810, s811, s812, s813, s814, s815, s816, s817
    , s818, s819, s820, s821, s822, s823, s824, s825
    , s826, s827, s828, s829, s830, s831, s832, s833
    , s834, s835, s836, s837, s838, s839, s840, s841
    , s842, s843, s844, s845, s846, s847, s848, s849
    , s850, s851, s852, t864, t865, t866, t867, t868
    , t869, t870, t871, t872, t873, t874, t875, t876
    , t877, t878, t879, t880, t881, t882, t883, t884
    , t885, t886, t887, t888, t889, t890, t891, t892
    , t893, t894, t895, t896, t897, t898, t899, t900
    , t901, t902, t903, t904, t905, t906, t907, t908
    , t909, t910, t911, t912, t913, t914, t915, t916
    , t917, t918, t919, t920, t921, t922, t923, t924
    , t925, t926, t927, t928, t929, t930, t931, t932
    , t933, t934, t935, t936, t937, t938, t939, t940
    , t941, t942, t943, t944, t945, t946, t947, t948
    , t949, t950, t951, t952, t953, t954, t955, t956
    , t957, t958, t959, t960, t961, t962, t963, t964
    , t965, t966, t967, t968, t969, t970, t971, t972
    , t973, t974, t975, t976, t977, t978, t979, t980
    , t981;
            a1758 = (((vector float  *) T26) + (2 * i14));
            s763 = *(a1758);
            s764 = *((a1758 + 1));
            s765 = *((a1758 + 256));
            s766 = *((a1758 + 257));
            t864 = spu_add(s763, s765);
            t865 = spu_add(s764, s766);
            t866 = spu_sub(s763, s765);
            t867 = spu_sub(s764, s766);
            s767 = *((a1758 + 128));
            s768 = *((a1758 + 129));
            s769 = *((a1758 + 384));
            s770 = *((a1758 + 385));
            t868 = spu_add(s767, s769);
            t869 = spu_add(s768, s770);
            t870 = spu_sub(s767, s769);
            t871 = spu_sub(s768, s770);
            t872 = spu_add(t864, t868);
            t873 = spu_add(t865, t869);
            t874 = spu_sub(t864, t868);
            t875 = spu_sub(t865, t869);
            t876 = spu_sub(t866, t871);
            t877 = spu_add(t867, t870);
            t878 = spu_add(t866, t871);
            t879 = spu_sub(t867, t870);
            s771 = *((a1758 + 32));
            s772 = *((a1758 + 33));
            s773 = *((a1758 + 288));
            s774 = *((a1758 + 289));
            t880 = spu_add(s771, s773);
            t881 = spu_add(s772, s774);
            t882 = spu_sub(s771, s773);
            t883 = spu_sub(s772, s774);
            s775 = *((a1758 + 160));
            s776 = *((a1758 + 161));
            s777 = *((a1758 + 416));
            s778 = *((a1758 + 417));
            t884 = spu_add(s775, s777);
            t885 = spu_add(s776, s778);
            t886 = spu_sub(s775, s777);
            t887 = spu_sub(s776, s778);
            t888 = spu_add(t880, t884);
            t889 = spu_add(t881, t885);
            t890 = spu_sub(t880, t884);
            t891 = spu_sub(t881, t885);
            s779 = spu_sub(t890, t891);
            s780 = spu_add(t890, t891);
            t892 = spu_sub(t882, t887);
            t893 = spu_add(t883, t886);
            t894 = spu_add(t882, t887);
            t895 = spu_sub(t883, t886);
            s781 = spu_nmsub(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t893, t892);
            s782 = spu_madd(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t893, t892);
            s783 = spu_nmsub(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t895, t894);
            s784 = spu_madd(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t895, t894);
            s785 = *((a1758 + 64));
            s786 = *((a1758 + 65));
            s787 = *((a1758 + 320));
            s788 = *((a1758 + 321));
            t896 = spu_add(s785, s787);
            t897 = spu_add(s786, s788);
            t898 = spu_sub(s785, s787);
            t899 = spu_sub(s786, s788);
            s789 = *((a1758 + 192));
            s790 = *((a1758 + 193));
            s791 = *((a1758 + 448));
            s792 = *((a1758 + 449));
            t900 = spu_add(s789, s791);
            t901 = spu_add(s790, s792);
            t902 = spu_sub(s789, s791);
            t903 = spu_sub(s790, s792);
            t904 = spu_add(t896, t900);
            t905 = spu_add(t897, t901);
            t906 = spu_sub(t896, t900);
            t907 = spu_sub(t897, t901);
            t908 = spu_sub(t898, t903);
            t909 = spu_add(t899, t902);
            t910 = spu_add(t898, t903);
            t911 = spu_sub(t899, t902);
            s793 = spu_sub(t908, t909);
            s794 = spu_add(t908, t909);
            s795 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), t911, t910);
            s796 = spu_add(spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), t910, ((vector float){0,0,0,0})), spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), t911, ((vector float){0,0,0,0})));
            s797 = *((a1758 + 96));
            s798 = *((a1758 + 97));
            s799 = *((a1758 + 352));
            s800 = *((a1758 + 353));
            t912 = spu_add(s797, s799);
            t913 = spu_add(s798, s800);
            t914 = spu_sub(s797, s799);
            t915 = spu_sub(s798, s800);
            s801 = *((a1758 + 224));
            s802 = *((a1758 + 225));
            s803 = *((a1758 + 480));
            s804 = *((a1758 + 481));
            t916 = spu_add(s801, s803);
            t917 = spu_add(s802, s804);
            t918 = spu_sub(s801, s803);
            t919 = spu_sub(s802, s804);
            t920 = spu_add(t912, t916);
            t921 = spu_add(t913, t917);
            t922 = spu_sub(t912, t916);
            t923 = spu_sub(t913, t917);
            s805 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), t923, t922);
            s806 = spu_add(spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), t922, ((vector float){0,0,0,0})), spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), t923, ((vector float){0,0,0,0})));
            t924 = spu_sub(t914, t919);
            t925 = spu_add(t915, t918);
            t926 = spu_add(t914, t919);
            t927 = spu_sub(t915, t918);
            s807 = spu_nmsub(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t925, t924);
            s808 = spu_madd(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t925, t924);
            s809 = spu_nmsub(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), t927, t926);
            s810 = spu_madd(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), t927, t926);
            t928 = spu_add(t872, t904);
            t929 = spu_add(t873, t905);
            t930 = spu_sub(t872, t904);
            t931 = spu_sub(t873, t905);
            t932 = spu_add(t888, t920);
            t933 = spu_add(t889, t921);
            t934 = spu_sub(t888, t920);
            t935 = spu_sub(t889, t921);
            t936 = spu_add(t928, t932);
            t937 = spu_add(t929, t933);
            t938 = spu_sub(t928, t932);
            t939 = spu_sub(t929, t933);
            a1759 = (((vector float  *) Y) + ((2 * i4) + (4 * i14)));
            s811 = spu_shuffle(t936, t937, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *(a1759) = s811;
            s812 = spu_shuffle(t936, t937, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 1)) = s812;
            s813 = spu_shuffle(t938, t939, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 512)) = s813;
            s814 = spu_shuffle(t938, t939, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 513)) = s814;
            t940 = spu_sub(t930, t935);
            t941 = spu_add(t931, t934);
            t942 = spu_add(t930, t935);
            t943 = spu_sub(t931, t934);
            s815 = spu_shuffle(t940, t941, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 256)) = s815;
            s816 = spu_shuffle(t940, t941, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 257)) = s816;
            s817 = spu_shuffle(t942, t943, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 768)) = s817;
            s818 = spu_shuffle(t942, t943, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 769)) = s818;
            t944 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s793, t876);
            t945 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s794, t877);
            t946 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s793, t876);
            t947 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s794, t877);
            s819 = spu_madd(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), s807, s781);
            s820 = spu_madd(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), s808, s782);
            s821 = spu_nmsub(((vector float){0.41421356237309509, 0.41421356237309509, 0.41421356237309509, 0.41421356237309509}), s807, s781);
            s822 = spu_nmsub(((vector float){2.4142135623730949, 2.4142135623730949, 2.4142135623730949, 2.4142135623730949}), s808, s782);
            t948 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s819, t944);
            t949 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s820, t945);
            t950 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s819, t944);
            t951 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s820, t945);
            s823 = spu_shuffle(t948, t949, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 64)) = s823;
            s824 = spu_shuffle(t948, t949, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 65)) = s824;
            s825 = spu_shuffle(t950, t951, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 576)) = s825;
            s826 = spu_shuffle(t950, t951, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 577)) = s826;
            t952 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s822, t946);
            t953 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s821, t947);
            t954 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s822, t946);
            t955 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s821, t947);
            s827 = spu_shuffle(t952, t953, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 320)) = s827;
            s828 = spu_shuffle(t952, t953, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 321)) = s828;
            s829 = spu_shuffle(t954, t955, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 832)) = s829;
            s830 = spu_shuffle(t954, t955, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 833)) = s830;
            t956 = spu_sub(t874, t907);
            t957 = spu_add(t875, t906);
            t958 = spu_add(t874, t907);
            t959 = spu_sub(t875, t906);
            s831 = spu_madd(((vector float){(-1), (-1), (-1), (-1)}), s805, s779);
            t960 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s780, s806);
            s832 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), s805, s779);
            t961 = spu_msub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s780, s806);
            t962 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s831, t956);
            t963 = spu_add(t957, t960);
            t964 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s831, t956);
            t965 = spu_sub(t957, t960);
            s833 = spu_shuffle(t962, t963, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 128)) = s833;
            s834 = spu_shuffle(t962, t963, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 129)) = s834;
            s835 = spu_shuffle(t964, t965, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 640)) = s835;
            s836 = spu_shuffle(t964, t965, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 641)) = s836;
            t966 = spu_sub(t958, t961);
            t967 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s832, t959);
            t968 = spu_add(t958, t961);
            t969 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s832, t959);
            s837 = spu_shuffle(t966, t967, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 384)) = s837;
            s838 = spu_shuffle(t966, t967, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 385)) = s838;
            s839 = spu_shuffle(t968, t969, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 896)) = s839;
            s840 = spu_shuffle(t968, t969, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 897)) = s840;
            t970 = spu_madd(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s795, t878);
            t971 = spu_add(t879, s796);
            t972 = spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s795, t878);
            t973 = spu_sub(t879, s796);
            s841 = spu_madd(((vector float){(-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949)}), s809, s783);
            s842 = spu_madd(((vector float){(-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509)}), s810, s784);
            s843 = spu_nmsub(((vector float){(-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949), (-2.4142135623730949)}), s809, s783);
            s844 = spu_nmsub(((vector float){(-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509), (-0.41421356237309509)}), s810, s784);
            t974 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s841, t970);
            t975 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s842, t971);
            t976 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s841, t970);
            t977 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s842, t971);
            s845 = spu_shuffle(t974, t975, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 192)) = s845;
            s846 = spu_shuffle(t974, t975, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 193)) = s846;
            s847 = spu_shuffle(t976, t977, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 704)) = s847;
            s848 = spu_shuffle(t976, t977, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 705)) = s848;
            t978 = spu_nmsub(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s844, t972);
            t979 = spu_madd(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s843, t973);
            t980 = spu_madd(((vector float){0.92387953251128674, 0.92387953251128674, 0.92387953251128674, 0.92387953251128674}), s844, t972);
            t981 = spu_nmsub(((vector float){0.38268343236508978, 0.38268343236508978, 0.38268343236508978, 0.38268343236508978}), s843, t973);
            s849 = spu_shuffle(t978, t979, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 448)) = s849;
            s850 = spu_shuffle(t978, t979, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 449)) = s850;
            s851 = spu_shuffle(t980, t981, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
            *((a1759 + 960)) = s851;
            s852 = spu_shuffle(t980, t981, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
            *((a1759 + 961)) = s852;
        }
    }
}
