/*************************************************************************
 * This code was generated by Spiral 6.0 beta, www.spiral.net --
 * Copyright (c) 2005-2008, Carnegie Mellon University.
 * All rights reserved.
 * The code is distributed under the GNU General Public License (GPL)
 * (see http://www.gnu.org/copyleft/gpl.html)

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * *AS IS* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *************************************************************************/


#include <spu_mfcio.h>

extern spe_infostruct spe_info;



#include "spumacros.h"






#include <math.h>
#include <spu_intrinsics.h>
#include <omega32.h>
static __attribute__((aligned(16))) vector float D3[176];
static __attribute__((aligned(16))) vector float D4[176];

void init_spu_dft() {
    for(int i10 = 0; i10 <= 10; i10++) {
        for(int i13 = 0; i13 <= 3; i13++) {
            D3[((i10 * 16) + (i13 * 4))] = spu_splats((float)cospi((((float)(2 * (i10 * i13))) / 88)));
            D3[((i10 * 16) + ((i13 * 4) + 1))] = spu_splats((float)sinpi((((float)(2 * (i10 * i13))) / 88)));
            D3[((i10 * 16) + ((i13 * 4) + 2))] = spu_splats((float)cospi((((float)(2 * (i10 * (4 + i13)))) / 88)));
            D3[((i10 * 16) + ((i13 * 4) + 3))] = spu_splats((float)sinpi((((float)(2 * (i10 * (4 + i13)))) / 88)));
        }
    }
    for(int i10 = 0; i10 <= 10; i10++) {
        for(int i14 = 0; i14 <= 1; i14++) {
            for(int i18 = 0; i18 <= 1; i18++) {
                D4[((i10 * 16) + ((i14 * 8) + (i18 * 4)))] = (vector float){1, cospi((((float)(2 * ((22 * i18) + ((11 * i14) + i10)))) / 352)), cospi((((float)(2 * (((22 * i18) + ((11 * i14) + i10)) * 2))) / 352)), cospi((((float)(2 * (((22 * i18) + ((11 * i14) + i10)) * 3))) / 352))};
                D4[((i10 * 16) + ((i14 * 8) + ((i18 * 4) + 1)))] = (vector float){0, sinpi((((float)(2 * ((22 * i18) + ((11 * i14) + i10)))) / 352)), sinpi((((float)(2 * (((22 * i18) + ((11 * i14) + i10)) * 2))) / 352)), sinpi((((float)(2 * (((22 * i18) + ((11 * i14) + i10)) * 3))) / 352))};
                D4[((i10 * 16) + ((i14 * 8) + ((i18 * 4) + 2)))] = (vector float){1, cospi((((float)(2 * (44 + ((22 * i18) + ((11 * i14) + i10))))) / 352)), cospi((((float)(2 * ((44 + ((22 * i18) + ((11 * i14) + i10))) * 2))) / 352)), cospi((((float)(2 * ((44 + ((22 * i18) + ((11 * i14) + i10))) * 3))) / 352))};
                D4[((i10 * 16) + ((i14 * 8) + ((i18 * 4) + 3)))] = (vector float){0, sinpi((((float)(2 * (44 + ((22 * i18) + ((11 * i14) + i10))))) / 352)), sinpi((((float)(2 * ((44 + ((22 * i18) + ((11 * i14) + i10))) * 2))) / 352)), sinpi((((float)(2 * ((44 + ((22 * i18) + ((11 * i14) + i10))) * 3))) / 352))};
            }
        }
    }
}

void spu_dft(float  *Y, float  *X) {
    static __attribute__((aligned(16))) float T1[704];
    static __attribute__((aligned(16))) float T2[704];
    for(int i20 = 0; i20 <= 21; i20++) {
        vector float  *a60, *a61;
        vector float s49, s50, s51, s52, s53, s54, s55
    , s56, s57, s58, s59, s60, s61, s62, s63
    , s64, s65, s66, s67, s68, s69, s70, s71
    , s72, t100, t101, t102, t103, t104, t105, t90
    , t91, t92, t93, t94, t95, t96, t97, t98
    , t99;
        a60 = (((vector float  *) X) + i20);
        s49 = *(a60);
        s50 = *((a60 + 88));
        s51 = *((a60 + 44));
        s52 = *((a60 + 132));
        t90 = spu_add(s49, s51);
        t91 = spu_add(s50, s52);
        t92 = spu_sub(s49, s51);
        t93 = spu_sub(s50, s52);
        s53 = *((a60 + 22));
        s54 = *((a60 + 110));
        s55 = *((a60 + 66));
        s56 = *((a60 + 154));
        t94 = spu_add(s53, s55);
        t95 = spu_add(s54, s56);
        t96 = spu_sub(s53, s55);
        t97 = spu_sub(s54, s56);
        t98 = spu_add(t90, t94);
        t99 = spu_add(t91, t95);
        t100 = spu_sub(t90, t94);
        t101 = spu_sub(t91, t95);
        t102 = spu_sub(t92, t97);
        t103 = spu_add(t93, t96);
        t104 = spu_add(t92, t97);
        t105 = spu_sub(t93, t96);
        s57 = spu_shuffle(t98, t102, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s58 = spu_shuffle(t98, t102, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s59 = spu_shuffle(t99, t103, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s60 = spu_shuffle(t99, t103, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s61 = spu_shuffle(t100, t104, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s62 = spu_shuffle(t100, t104, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s63 = spu_shuffle(t101, t105, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s64 = spu_shuffle(t101, t105, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        a61 = (((vector float  *) T2) + (8 * i20));
        s65 = spu_shuffle(s57, s61, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *(a61) = s65;
        s66 = spu_shuffle(s57, s61, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 2)) = s66;
        s67 = spu_shuffle(s58, s62, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a61 + 4)) = s67;
        s68 = spu_shuffle(s58, s62, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 6)) = s68;
        s69 = spu_shuffle(s59, s63, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a61 + 1)) = s69;
        s70 = spu_shuffle(s59, s63, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 3)) = s70;
        s71 = spu_shuffle(s60, s64, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a61 + 5)) = s71;
        s72 = spu_shuffle(s60, s64, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 7)) = s72;
    }
    for(int i10 = 0; i10 <= 10; i10++) {
        int a594;
        vector float  *a593, *a595, *a612, *a617;
        vector float a596, a597, a598, a599, a600, a601, a602
    , a603, a604, a605, a606, a607, a608, a609, a610
    , a611, a613, a614, a615, a616, a618, a619, a620
    , a621, a622, a623, a624, a625, a626, a627, a628
    , a629, s180, s181, s182, s183, s184, s185, s186
    , s187, s188, s189, s190, s191, s192, s193, s194
    , s195, s196, s197, s198, s199, s200, s201, s202
    , s203, s204, s205, s206, s207, s208, s209, s210
    , s211, s212, s213, s214, s215, s216, s217, s218
    , s219, s220, s221, s222, s223, s224, s225, s226
    , s227, s228, s229, s230, s231, t202, t203, t204
    , t205, t206, t207, t208, t209, t210, t211, t212
    , t213, t214, t215, t216, t217, t218, t219, t220
    , t221, t222, t223, t224, t225, t226, t227, t228
    , t229, t230, t231, t232, t233, t234, t235, t236
    , t237, t238, t239, t240, t241, t242, t243, t244
    , t245, t246, t247, t248, t249;
        a593 = (((vector float  *) T2) + (2 * i10));
        s180 = *(a593);
        s181 = *((a593 + 1));
        s182 = *((a593 + 88));
        s183 = *((a593 + 89));
        a594 = (16 * i10);
        a595 = (D4 + a594);
        a596 = *(a595);
        a597 = *((a595 + 1));
        s184 = spu_sub(spu_mul(a596, s180), spu_mul(a597, s181));
        s185 = spu_add(spu_mul(a597, s180), spu_mul(a596, s181));
        a598 = *((a595 + 2));
        a599 = *((a595 + 3));
        s186 = spu_sub(spu_mul(a598, s182), spu_mul(a599, s183));
        s187 = spu_add(spu_mul(a599, s182), spu_mul(a598, s183));
        t202 = spu_add(s184, s186);
        t203 = spu_add(s185, s187);
        t204 = spu_sub(s184, s186);
        t205 = spu_sub(s185, s187);
        s188 = *((a593 + 44));
        s189 = *((a593 + 45));
        s190 = *((a593 + 132));
        s191 = *((a593 + 133));
        a600 = *((a595 + 4));
        a601 = *((a595 + 5));
        s192 = spu_sub(spu_mul(a600, s188), spu_mul(a601, s189));
        s193 = spu_add(spu_mul(a601, s188), spu_mul(a600, s189));
        a602 = *((a595 + 6));
        a603 = *((a595 + 7));
        s194 = spu_sub(spu_mul(a602, s190), spu_mul(a603, s191));
        s195 = spu_add(spu_mul(a603, s190), spu_mul(a602, s191));
        t206 = spu_add(s192, s194);
        t207 = spu_add(s193, s195);
        t208 = spu_sub(s192, s194);
        t209 = spu_sub(s193, s195);
        t210 = spu_add(t202, t206);
        t211 = spu_add(t203, t207);
        t212 = spu_sub(t202, t206);
        t213 = spu_sub(t203, t207);
        t214 = spu_sub(t204, t209);
        t215 = spu_add(t205, t208);
        t216 = spu_add(t204, t209);
        t217 = spu_sub(t205, t208);
        s196 = *((a593 + 22));
        s197 = *((a593 + 23));
        s198 = *((a593 + 110));
        s199 = *((a593 + 111));
        a604 = *((a595 + 8));
        a605 = *((a595 + 9));
        s200 = spu_sub(spu_mul(a604, s196), spu_mul(a605, s197));
        s201 = spu_add(spu_mul(a605, s196), spu_mul(a604, s197));
        a606 = *((a595 + 10));
        a607 = *((a595 + 11));
        s202 = spu_sub(spu_mul(a606, s198), spu_mul(a607, s199));
        s203 = spu_add(spu_mul(a607, s198), spu_mul(a606, s199));
        t218 = spu_add(s200, s202);
        t219 = spu_add(s201, s203);
        t220 = spu_sub(s200, s202);
        t221 = spu_sub(s201, s203);
        s204 = *((a593 + 66));
        s205 = *((a593 + 67));
        s206 = *((a593 + 154));
        s207 = *((a593 + 155));
        a608 = *((a595 + 12));
        a609 = *((a595 + 13));
        s208 = spu_sub(spu_mul(a608, s204), spu_mul(a609, s205));
        s209 = spu_add(spu_mul(a609, s204), spu_mul(a608, s205));
        a610 = *((a595 + 14));
        a611 = *((a595 + 15));
        s210 = spu_sub(spu_mul(a610, s206), spu_mul(a611, s207));
        s211 = spu_add(spu_mul(a611, s206), spu_mul(a610, s207));
        t222 = spu_add(s208, s210);
        t223 = spu_add(s209, s211);
        t224 = spu_sub(s208, s210);
        t225 = spu_sub(s209, s211);
        t226 = spu_add(t218, t222);
        t227 = spu_add(t219, t223);
        t228 = spu_sub(t218, t222);
        t229 = spu_sub(t219, t223);
        t230 = spu_sub(t220, t225);
        t231 = spu_add(t221, t224);
        t232 = spu_add(t220, t225);
        t233 = spu_sub(t221, t224);
        s212 = spu_sub(t230, t231);
        s213 = spu_add(t230, t231);
        s214 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), t233, t232);
        s215 = spu_add(spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), t232, ((vector float){0,0,0,0})), spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), t233, ((vector float){0,0,0,0})));
        t234 = spu_add(t210, t226);
        t235 = spu_add(t211, t227);
        t236 = spu_sub(t210, t226);
        t237 = spu_sub(t211, t227);
        a612 = (D3 + a594);
        a613 = *(a612);
        a614 = *((a612 + 1));
        a615 = *((a612 + 2));
        a616 = *((a612 + 3));
        a617 = (((vector float  *) T1) + a594);
        s216 = spu_sub(spu_mul(a613, t234), spu_mul(a614, t235));
        *(a617) = s216;
        s217 = spu_add(spu_mul(a614, t234), spu_mul(a613, t235));
        *((a617 + 1)) = s217;
        s218 = spu_sub(spu_mul(a615, t236), spu_mul(a616, t237));
        *((a617 + 8)) = s218;
        s219 = spu_add(spu_mul(a616, t236), spu_mul(a615, t237));
        *((a617 + 9)) = s219;
        t238 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s212, t214);
        t239 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s213, t215);
        t240 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s212, t214);
        t241 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s213, t215);
        a618 = *((a612 + 4));
        a619 = *((a612 + 5));
        a620 = *((a612 + 6));
        a621 = *((a612 + 7));
        s220 = spu_sub(spu_mul(a618, t238), spu_mul(a619, t239));
        *((a617 + 2)) = s220;
        s221 = spu_add(spu_mul(a619, t238), spu_mul(a618, t239));
        *((a617 + 3)) = s221;
        s222 = spu_sub(spu_mul(a620, t240), spu_mul(a621, t241));
        *((a617 + 10)) = s222;
        s223 = spu_add(spu_mul(a621, t240), spu_mul(a620, t241));
        *((a617 + 11)) = s223;
        t242 = spu_sub(t212, t229);
        t243 = spu_add(t213, t228);
        t244 = spu_add(t212, t229);
        t245 = spu_sub(t213, t228);
        a622 = *((a612 + 8));
        a623 = *((a612 + 9));
        a624 = *((a612 + 10));
        a625 = *((a612 + 11));
        s224 = spu_sub(spu_mul(a622, t242), spu_mul(a623, t243));
        *((a617 + 4)) = s224;
        s225 = spu_add(spu_mul(a623, t242), spu_mul(a622, t243));
        *((a617 + 5)) = s225;
        s226 = spu_sub(spu_mul(a624, t244), spu_mul(a625, t245));
        *((a617 + 12)) = s226;
        s227 = spu_add(spu_mul(a625, t244), spu_mul(a624, t245));
        *((a617 + 13)) = s227;
        t246 = spu_madd(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s214, t216);
        t247 = spu_add(t217, s215);
        t248 = spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s214, t216);
        t249 = spu_sub(t217, s215);
        a626 = *((a612 + 12));
        a627 = *((a612 + 13));
        a628 = *((a612 + 14));
        a629 = *((a612 + 15));
        s228 = spu_sub(spu_mul(a626, t246), spu_mul(a627, t247));
        *((a617 + 6)) = s228;
        s229 = spu_add(spu_mul(a627, t246), spu_mul(a626, t247));
        *((a617 + 7)) = s229;
        s230 = spu_sub(spu_mul(a628, t248), spu_mul(a629, t249));
        *((a617 + 14)) = s230;
        s231 = spu_add(spu_mul(a629, t248), spu_mul(a628, t249));
        *((a617 + 15)) = s231;
    }
    for(int i5 = 0; i5 <= 7; i5++) {
        vector float  *a967, *a968;
        vector float s316, s317, s318, s319, s320, s321, s322
    , s323, s324, s325, s326, s327, s328, s329, s330
    , s331, s332, s333, s334, s335, s336, s337, s338
    , s339, s340, s341, s342, s343, s344, s345, s346
    , s347, s348, s349, s350, s351, s352, s353, s354
    , s355, s356, s357, s358, s359, s360, s361, s362
    , s363, s364, s365, s366, s367, s368, s369, s370
    , s371, s372, s373, s374, s375, s376, s377, s378
    , s379, s380, s381, s382, s383, s384, s385, s387
    , s388, s389, s390, s391, s392, s393, s394, s395
    , s396, s397, s398, s399, s400, t551, t552, t553
    , t554, t555, t556, t557, t558, t559, t560, t561
    , t562, t563, t564, t565, t566, t567, t568, t569
    , t570, t571, t572, t573, t574, t575, t576, t577
    , t578, t579, t580;
        a967 = (((vector float  *) T1) + (2 * i5));
        s316 = *(a967);
        s317 = *((a967 + 1));
        s318 = *((a967 + 16));
        s319 = *((a967 + 17));
        s320 = *((a967 + 160));
        s321 = *((a967 + 161));
        t551 = spu_add(s318, s320);
        t552 = spu_add(s319, s321);
        t553 = spu_sub(s318, s320);
        t554 = spu_sub(s319, s321);
        s322 = *((a967 + 96));
        s323 = *((a967 + 97));
        s324 = *((a967 + 80));
        s325 = *((a967 + 81));
        t555 = spu_add(s322, s324);
        t556 = spu_add(s323, s325);
        t557 = spu_sub(s322, s324);
        t558 = spu_sub(s323, s325);
        s326 = *((a967 + 48));
        s327 = *((a967 + 49));
        s328 = *((a967 + 128));
        s329 = *((a967 + 129));
        t559 = spu_add(s326, s328);
        t560 = spu_add(s327, s329);
        t561 = spu_sub(s326, s328);
        t562 = spu_sub(s327, s329);
        s330 = *((a967 + 112));
        s331 = *((a967 + 113));
        s332 = *((a967 + 64));
        s333 = *((a967 + 65));
        t563 = spu_add(s330, s332);
        t564 = spu_add(s331, s333);
        t565 = spu_sub(s330, s332);
        t566 = spu_sub(s331, s333);
        s334 = *((a967 + 144));
        s335 = *((a967 + 145));
        s336 = *((a967 + 32));
        s337 = *((a967 + 33));
        t567 = spu_add(s334, s336);
        t568 = spu_add(s335, s337);
        t569 = spu_sub(s334, s336);
        t570 = spu_sub(s335, s337);
        t571 = spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t567, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t563, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t559, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t555, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t551, s316)))));
        t572 = spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t568, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t564, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t560, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t556, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t552, s317)))));
        t573 = spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t567, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t563, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t559, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t555, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t551, s316)))));
        t574 = spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t568, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t564, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t560, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t556, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t552, s317)))));
        t575 = spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t567, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t563, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t559, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t555, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t551, s316)))));
        t576 = spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t568, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t564, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t560, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t556, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t552, s317)))));
        t577 = spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t567, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t563, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t559, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t555, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t551, s316)))));
        t578 = spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t568, spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t564, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t560, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t556, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t552, s317)))));
        t579 = spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t567, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t563, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t559, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t555, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t551, s316)))));
        t580 = spu_madd(((vector float){0.84125353283118121,0.84125353283118121,0.84125353283118121,0.84125353283118121}), t568, spu_madd(((vector float){0.41541501300188644,0.41541501300188644,0.41541501300188644,0.41541501300188644}), t564, spu_nmsub(((vector float){0.6548607339452851,0.6548607339452851,0.6548607339452851,0.6548607339452851}), t560, spu_nmsub(((vector float){0.14231483827328514,0.14231483827328514,0.14231483827328514,0.14231483827328514}), t556, spu_nmsub(((vector float){0.95949297361449737,0.95949297361449737,0.95949297361449737,0.95949297361449737}), t552, s317)))));
        s338 = spu_nmsub(((vector float){1.918985947228995,1.918985947228995,1.918985947228995,1.918985947228995}), t554, t558);
        s339 = spu_nmsub(((vector float){3.5133370916661355,3.5133370916661355,3.5133370916661355,3.5133370916661355}), t562, s338);
        s340 = spu_madd(((vector float){2.6825070656623624,2.6825070656623624,2.6825070656623624,2.6825070656623624}), t566, s339);
        s341 = spu_madd(((vector float){3.2287074151195649,3.2287074151195649,3.2287074151195649,3.2287074151195649}), t570, s340);
        s342 = spu_nmsub(((vector float){0.52110855811320267,0.52110855811320267,0.52110855811320267,0.52110855811320267}), t557, t553);
        s343 = spu_madd(((vector float){1.8308300260037729,1.8308300260037729,1.8308300260037729,1.8308300260037729}), t561, s342);
        s344 = spu_nmsub(((vector float){1.3978773891157921,1.3978773891157921,1.3978773891157921,1.3978773891157921}), t565, s343);
        s345 = spu_nmsub(((vector float){1.6825070656623624,1.6825070656623624,1.6825070656623624,1.6825070656623624}), t569, s344);
        s346 = spu_madd(((vector float){0.59435114443714043,0.59435114443714043,0.59435114443714043,0.59435114443714043}), t558, t554);
        s347 = spu_nmsub(((vector float){3.2287074151195649,3.2287074151195649,3.2287074151195649,3.2287074151195649}), s346, t562);
        s348 = spu_nmsub(((vector float){3.5133370916661355,3.5133370916661355,3.5133370916661355,3.5133370916661355}), t566, s347);
        s349 = spu_madd(((vector float){2.6825070656623624,2.6825070656623624,2.6825070656623624,2.6825070656623624}), t570, s348);
        s350 = spu_madd(((vector float){0.59435114443714043,0.59435114443714043,0.59435114443714043,0.59435114443714043}), t557, t553);
        s351 = spu_nmsub(((vector float){0.30972146789057009,0.30972146789057009,0.30972146789057009,0.30972146789057009}), t561, s350);
        s352 = spu_madd(((vector float){1.0881559212252219,1.0881559212252219,1.0881559212252219,1.0881559212252219}), t565, s351);
        s353 = spu_nmsub(((vector float){0.83083002600377287,0.83083002600377287,0.83083002600377287,0.83083002600377287}), t569, s352);
        s354 = spu_madd(((vector float){1.2036156237755651,1.2036156237755651,1.2036156237755651,1.2036156237755651}), t558, t554);
        s355 = spu_madd(((vector float){0.71537032345342966,0.71537032345342966,0.71537032345342966,0.71537032345342966}), t562, s354);
        s356 = spu_nmsub(((vector float){2.6825070656623624,2.6825070656623624,2.6825070656623624,2.6825070656623624}), s355, t566);
        s357 = spu_nmsub(((vector float){3.5133370916661355,3.5133370916661355,3.5133370916661355,3.5133370916661355}), t570, s356);
        s358 = spu_madd(((vector float){1.2036156237755651,1.2036156237755651,1.2036156237755651,1.2036156237755651}), t557, t553);
        s359 = spu_madd(((vector float){0.71537032345342966,0.71537032345342966,0.71537032345342966,0.71537032345342966}), t561, s358);
        s360 = spu_nmsub(((vector float){0.37278559777179215,0.37278559777179215,0.37278559777179215,0.37278559777179215}), t565, s359);
        s361 = spu_madd(((vector float){1.30972146789057,1.30972146789057,1.30972146789057,1.30972146789057}), t569, s360);
        s362 = spu_nmsub(((vector float){0.76352111843336756,0.76352111843336756,0.76352111843336756,0.76352111843336756}), t558, t554);
        s363 = spu_nmsub(((vector float){0.91898594722899474,0.91898594722899474,0.91898594722899474,0.91898594722899474}), t562, s362);
        s364 = spu_nmsub(((vector float){0.54620034945720253,0.54620034945720253,0.54620034945720253,0.54620034945720253}), t566, s363);
        s365 = spu_madd(((vector float){0.28462967654657029,0.28462967654657029,0.28462967654657029,0.28462967654657029}), t570, s364);
        s366 = spu_nmsub(((vector float){1.30972146789057,1.30972146789057,1.30972146789057,1.30972146789057}), t553, t557);
        s367 = spu_madd(((vector float){1.2036156237755651,1.2036156237755651,1.2036156237755651,1.2036156237755651}), t561, s366);
        s368 = spu_madd(((vector float){0.71537032345342966,0.71537032345342966,0.71537032345342966,0.71537032345342966}), t565, s367);
        s369 = spu_nmsub(((vector float){0.37278559777179215,0.37278559777179215,0.37278559777179215,0.37278559777179215}), t569, s368);
        s370 = spu_nmsub(((vector float){0.28462967654657029,0.28462967654657029,0.28462967654657029,0.28462967654657029}), t554, t558);
        s371 = spu_nmsub(((vector float){0.76352111843336756,0.76352111843336756,0.76352111843336756,0.76352111843336756}), t562, s370);
        s372 = spu_nmsub(((vector float){0.91898594722899474,0.91898594722899474,0.91898594722899474,0.91898594722899474}), t566, s371);
        s373 = spu_nmsub(((vector float){0.54620034945720253,0.54620034945720253,0.54620034945720253,0.54620034945720253}), t570, s372);
        s374 = spu_nmsub(((vector float){3.5133370916661355,3.5133370916661355,3.5133370916661355,3.5133370916661355}), t557, t553);
        s375 = spu_madd(((vector float){2.6825070656623624,2.6825070656623624,2.6825070656623624,2.6825070656623624}), t561, s374);
        s376 = spu_madd(((vector float){3.2287074151195649,3.2287074151195649,3.2287074151195649,3.2287074151195649}), t565, s375);
        s377 = spu_madd(((vector float){1.918985947228995,1.918985947228995,1.918985947228995,1.918985947228995}), t569, s376);
        a968 = (((vector float  *) Y) + i5);
        s378 = spu_add(s316, spu_add(t551, spu_add(t555, spu_add(t559, spu_add(t563, t567)))));
        *(a968) = s378;
        s379 = spu_add(s317, spu_add(t552, spu_add(t556, spu_add(t560, spu_add(t564, t568)))));
        *((a968 + 88)) = s379;
        s380 = spu_madd(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s341, t571);
        *((a968 + 8)) = s380;
        s381 = spu_madd(((vector float){0.54064081745559756,0.54064081745559756,0.54064081745559756,0.54064081745559756}), s345, t572);
        *((a968 + 96)) = s381;
        s382 = spu_nmsub(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s341, t571);
        *((a968 + 80)) = s382;
        s383 = spu_nmsub(((vector float){0.54064081745559756,0.54064081745559756,0.54064081745559756,0.54064081745559756}), s345, t572);
        *((a968 + 168)) = s383;
        s384 = spu_madd(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s349, t573);
        *((a968 + 16)) = s384;
        s385 = spu_madd(((vector float){0.90963199535451833,0.90963199535451833,0.90963199535451833,0.90963199535451833}), s353, t574);
        *((a968 + 104)) = s385;
        s387 = spu_nmsub(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s349, t573);
        *((a968 + 72)) = s387;
        s388 = spu_nmsub(((vector float){0.90963199535451833,0.90963199535451833,0.90963199535451833,0.90963199535451833}), s353, t574);
        *((a968 + 160)) = s388;
        s389 = spu_madd(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s357, t575);
        *((a968 + 32)) = s389;
        s390 = spu_madd(((vector float){0.75574957435425827,0.75574957435425827,0.75574957435425827,0.75574957435425827}), s361, t576);
        *((a968 + 120)) = s390;
        s391 = spu_nmsub(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s357, t575);
        *((a968 + 56)) = s391;
        s392 = spu_nmsub(((vector float){0.75574957435425827,0.75574957435425827,0.75574957435425827,0.75574957435425827}), s361, t576);
        *((a968 + 144)) = s392;
        s393 = spu_madd(((vector float){0.98982144188093268,0.98982144188093268,0.98982144188093268,0.98982144188093268}), s365, t577);
        *((a968 + 64)) = s393;
        s394 = spu_madd(((vector float){0.75574957435425827,0.75574957435425827,0.75574957435425827,0.75574957435425827}), s369, t578);
        *((a968 + 152)) = s394;
        s395 = spu_nmsub(((vector float){0.98982144188093268,0.98982144188093268,0.98982144188093268,0.98982144188093268}), s365, t577);
        *((a968 + 24)) = s395;
        s396 = spu_nmsub(((vector float){0.75574957435425827,0.75574957435425827,0.75574957435425827,0.75574957435425827}), s369, t578);
        *((a968 + 112)) = s396;
        s397 = spu_madd(((vector float){0.98982144188093268,0.98982144188093268,0.98982144188093268,0.98982144188093268}), s373, t579);
        *((a968 + 40)) = s397;
        s398 = spu_madd(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s377, t580);
        *((a968 + 128)) = s398;
        s399 = spu_nmsub(((vector float){0.98982144188093268,0.98982144188093268,0.98982144188093268,0.98982144188093268}), s373, t579);
        *((a968 + 48)) = s399;
        s400 = spu_nmsub(((vector float){0.28173255684142967,0.28173255684142967,0.28173255684142967,0.28173255684142967}), s377, t580);
        *((a968 + 136)) = s400;
    }
}
