/*************************************************************************
 * This code was generated by Spiral 6.0 beta, www.spiral.net --
 * Copyright (c) 2005-2008, Carnegie Mellon University.
 * All rights reserved.
 * The code is distributed under the GNU General Public License (GPL)
 * (see http://www.gnu.org/copyleft/gpl.html)

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * *AS IS* AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *************************************************************************/


#include <spu_mfcio.h>

extern spe_infostruct spe_info;



#include "spumacros.h"






#include <math.h>
#include <spu_intrinsics.h>
#include <omega32.h>
static __attribute__((aligned(16))) vector float D3[208];
static __attribute__((aligned(16))) vector float D4[208];

void init_spu_dft() {
    for(int i10 = 0; i10 <= 12; i10++) {
        for(int i13 = 0; i13 <= 3; i13++) {
            D3[((i10 * 16) + (i13 * 4))] = spu_splats((float)cospi((((float)(2 * (i10 * i13))) / 104)));
            D3[((i10 * 16) + ((i13 * 4) + 1))] = spu_splats((float)sinpi((((float)(2 * (i10 * i13))) / 104)));
            D3[((i10 * 16) + ((i13 * 4) + 2))] = spu_splats((float)cospi((((float)(2 * (i10 * (4 + i13)))) / 104)));
            D3[((i10 * 16) + ((i13 * 4) + 3))] = spu_splats((float)sinpi((((float)(2 * (i10 * (4 + i13)))) / 104)));
        }
    }
    for(int i10 = 0; i10 <= 12; i10++) {
        for(int i14 = 0; i14 <= 1; i14++) {
            for(int i18 = 0; i18 <= 1; i18++) {
                D4[((i10 * 16) + ((i14 * 8) + (i18 * 4)))] = (vector float){1, cospi((((float)(2 * ((26 * i18) + ((13 * i14) + i10)))) / 416)), cospi((((float)(2 * (((26 * i18) + ((13 * i14) + i10)) * 2))) / 416)), cospi((((float)(2 * (((26 * i18) + ((13 * i14) + i10)) * 3))) / 416))};
                D4[((i10 * 16) + ((i14 * 8) + ((i18 * 4) + 1)))] = (vector float){0, sinpi((((float)(2 * ((26 * i18) + ((13 * i14) + i10)))) / 416)), sinpi((((float)(2 * (((26 * i18) + ((13 * i14) + i10)) * 2))) / 416)), sinpi((((float)(2 * (((26 * i18) + ((13 * i14) + i10)) * 3))) / 416))};
                D4[((i10 * 16) + ((i14 * 8) + ((i18 * 4) + 2)))] = (vector float){1, cospi((((float)(2 * (52 + ((26 * i18) + ((13 * i14) + i10))))) / 416)), cospi((((float)(2 * ((52 + ((26 * i18) + ((13 * i14) + i10))) * 2))) / 416)), cospi((((float)(2 * ((52 + ((26 * i18) + ((13 * i14) + i10))) * 3))) / 416))};
                D4[((i10 * 16) + ((i14 * 8) + ((i18 * 4) + 3)))] = (vector float){0, sinpi((((float)(2 * (52 + ((26 * i18) + ((13 * i14) + i10))))) / 416)), sinpi((((float)(2 * ((52 + ((26 * i18) + ((13 * i14) + i10))) * 2))) / 416)), sinpi((((float)(2 * ((52 + ((26 * i18) + ((13 * i14) + i10))) * 3))) / 416))};
            }
        }
    }
}

void spu_dft(float  *Y, float  *X) {
    static __attribute__((aligned(16))) float T1[832];
    static __attribute__((aligned(16))) float T2[832];
    for(int i20 = 0; i20 <= 25; i20++) {
        vector float  *a60, *a61;
        vector float s49, s50, s51, s52, s53, s54, s55
    , s56, s57, s58, s59, s60, s61, s62, s63
    , s64, s65, s66, s67, s68, s69, s70, s71
    , s72, t100, t101, t102, t103, t104, t105, t90
    , t91, t92, t93, t94, t95, t96, t97, t98
    , t99;
        a60 = (((vector float  *) X) + i20);
        s49 = *(a60);
        s50 = *((a60 + 104));
        s51 = *((a60 + 52));
        s52 = *((a60 + 156));
        t90 = spu_add(s49, s51);
        t91 = spu_add(s50, s52);
        t92 = spu_sub(s49, s51);
        t93 = spu_sub(s50, s52);
        s53 = *((a60 + 26));
        s54 = *((a60 + 130));
        s55 = *((a60 + 78));
        s56 = *((a60 + 182));
        t94 = spu_add(s53, s55);
        t95 = spu_add(s54, s56);
        t96 = spu_sub(s53, s55);
        t97 = spu_sub(s54, s56);
        t98 = spu_add(t90, t94);
        t99 = spu_add(t91, t95);
        t100 = spu_sub(t90, t94);
        t101 = spu_sub(t91, t95);
        t102 = spu_sub(t92, t97);
        t103 = spu_add(t93, t96);
        t104 = spu_add(t92, t97);
        t105 = spu_sub(t93, t96);
        s57 = spu_shuffle(t98, t102, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s58 = spu_shuffle(t98, t102, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s59 = spu_shuffle(t99, t103, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s60 = spu_shuffle(t99, t103, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s61 = spu_shuffle(t100, t104, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s62 = spu_shuffle(t100, t104, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        s63 = spu_shuffle(t101, t105, ((vector unsigned char){0, 1, 2, 3, 16, 17, 18, 19, 4, 5, 6, 7, 20, 21, 22, 23}));
        s64 = spu_shuffle(t101, t105, ((vector unsigned char){8, 9, 10, 11, 24, 25, 26, 27, 12, 13, 14, 15, 28, 29, 30, 31}));
        a61 = (((vector float  *) T2) + (8 * i20));
        s65 = spu_shuffle(s57, s61, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *(a61) = s65;
        s66 = spu_shuffle(s57, s61, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 2)) = s66;
        s67 = spu_shuffle(s58, s62, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a61 + 4)) = s67;
        s68 = spu_shuffle(s58, s62, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 6)) = s68;
        s69 = spu_shuffle(s59, s63, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a61 + 1)) = s69;
        s70 = spu_shuffle(s59, s63, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 3)) = s70;
        s71 = spu_shuffle(s60, s64, ((vector unsigned char){0, 1, 2, 3, 4, 5, 6, 7, 16, 17, 18, 19, 20, 21, 22, 23}));
        *((a61 + 5)) = s71;
        s72 = spu_shuffle(s60, s64, ((vector unsigned char){8, 9, 10, 11, 12, 13, 14, 15, 24, 25, 26, 27, 28, 29, 30, 31}));
        *((a61 + 7)) = s72;
    }
    for(int i10 = 0; i10 <= 12; i10++) {
        int a594;
        vector float  *a593, *a595, *a612, *a617;
        vector float a596, a597, a598, a599, a600, a601, a602
    , a603, a604, a605, a606, a607, a608, a609, a610
    , a611, a613, a614, a615, a616, a618, a619, a620
    , a621, a622, a623, a624, a625, a626, a627, a628
    , a629, s180, s181, s182, s183, s184, s185, s186
    , s187, s188, s189, s190, s191, s192, s193, s194
    , s195, s196, s197, s198, s199, s200, s201, s202
    , s203, s204, s205, s206, s207, s208, s209, s210
    , s211, s212, s213, s214, s215, s216, s217, s218
    , s219, s220, s221, s222, s223, s224, s225, s226
    , s227, s228, s229, s230, s231, t202, t203, t204
    , t205, t206, t207, t208, t209, t210, t211, t212
    , t213, t214, t215, t216, t217, t218, t219, t220
    , t221, t222, t223, t224, t225, t226, t227, t228
    , t229, t230, t231, t232, t233, t234, t235, t236
    , t237, t238, t239, t240, t241, t242, t243, t244
    , t245, t246, t247, t248, t249;
        a593 = (((vector float  *) T2) + (2 * i10));
        s180 = *(a593);
        s181 = *((a593 + 1));
        s182 = *((a593 + 104));
        s183 = *((a593 + 105));
        a594 = (16 * i10);
        a595 = (D4 + a594);
        a596 = *(a595);
        a597 = *((a595 + 1));
        s184 = spu_sub(spu_mul(a596, s180), spu_mul(a597, s181));
        s185 = spu_add(spu_mul(a597, s180), spu_mul(a596, s181));
        a598 = *((a595 + 2));
        a599 = *((a595 + 3));
        s186 = spu_sub(spu_mul(a598, s182), spu_mul(a599, s183));
        s187 = spu_add(spu_mul(a599, s182), spu_mul(a598, s183));
        t202 = spu_add(s184, s186);
        t203 = spu_add(s185, s187);
        t204 = spu_sub(s184, s186);
        t205 = spu_sub(s185, s187);
        s188 = *((a593 + 52));
        s189 = *((a593 + 53));
        s190 = *((a593 + 156));
        s191 = *((a593 + 157));
        a600 = *((a595 + 4));
        a601 = *((a595 + 5));
        s192 = spu_sub(spu_mul(a600, s188), spu_mul(a601, s189));
        s193 = spu_add(spu_mul(a601, s188), spu_mul(a600, s189));
        a602 = *((a595 + 6));
        a603 = *((a595 + 7));
        s194 = spu_sub(spu_mul(a602, s190), spu_mul(a603, s191));
        s195 = spu_add(spu_mul(a603, s190), spu_mul(a602, s191));
        t206 = spu_add(s192, s194);
        t207 = spu_add(s193, s195);
        t208 = spu_sub(s192, s194);
        t209 = spu_sub(s193, s195);
        t210 = spu_add(t202, t206);
        t211 = spu_add(t203, t207);
        t212 = spu_sub(t202, t206);
        t213 = spu_sub(t203, t207);
        t214 = spu_sub(t204, t209);
        t215 = spu_add(t205, t208);
        t216 = spu_add(t204, t209);
        t217 = spu_sub(t205, t208);
        s196 = *((a593 + 26));
        s197 = *((a593 + 27));
        s198 = *((a593 + 130));
        s199 = *((a593 + 131));
        a604 = *((a595 + 8));
        a605 = *((a595 + 9));
        s200 = spu_sub(spu_mul(a604, s196), spu_mul(a605, s197));
        s201 = spu_add(spu_mul(a605, s196), spu_mul(a604, s197));
        a606 = *((a595 + 10));
        a607 = *((a595 + 11));
        s202 = spu_sub(spu_mul(a606, s198), spu_mul(a607, s199));
        s203 = spu_add(spu_mul(a607, s198), spu_mul(a606, s199));
        t218 = spu_add(s200, s202);
        t219 = spu_add(s201, s203);
        t220 = spu_sub(s200, s202);
        t221 = spu_sub(s201, s203);
        s204 = *((a593 + 78));
        s205 = *((a593 + 79));
        s206 = *((a593 + 182));
        s207 = *((a593 + 183));
        a608 = *((a595 + 12));
        a609 = *((a595 + 13));
        s208 = spu_sub(spu_mul(a608, s204), spu_mul(a609, s205));
        s209 = spu_add(spu_mul(a609, s204), spu_mul(a608, s205));
        a610 = *((a595 + 14));
        a611 = *((a595 + 15));
        s210 = spu_sub(spu_mul(a610, s206), spu_mul(a611, s207));
        s211 = spu_add(spu_mul(a611, s206), spu_mul(a610, s207));
        t222 = spu_add(s208, s210);
        t223 = spu_add(s209, s211);
        t224 = spu_sub(s208, s210);
        t225 = spu_sub(s209, s211);
        t226 = spu_add(t218, t222);
        t227 = spu_add(t219, t223);
        t228 = spu_sub(t218, t222);
        t229 = spu_sub(t219, t223);
        t230 = spu_sub(t220, t225);
        t231 = spu_add(t221, t224);
        t232 = spu_add(t220, t225);
        t233 = spu_sub(t221, t224);
        s212 = spu_sub(t230, t231);
        s213 = spu_add(t230, t231);
        s214 = spu_nmsub(((vector float){(-1), (-1), (-1), (-1)}), t233, t232);
        s215 = spu_add(spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), t232, ((vector float){0,0,0,0})), spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), t233, ((vector float){0,0,0,0})));
        t234 = spu_add(t210, t226);
        t235 = spu_add(t211, t227);
        t236 = spu_sub(t210, t226);
        t237 = spu_sub(t211, t227);
        a612 = (D3 + a594);
        a613 = *(a612);
        a614 = *((a612 + 1));
        a615 = *((a612 + 2));
        a616 = *((a612 + 3));
        a617 = (((vector float  *) T1) + a594);
        s216 = spu_sub(spu_mul(a613, t234), spu_mul(a614, t235));
        *(a617) = s216;
        s217 = spu_add(spu_mul(a614, t234), spu_mul(a613, t235));
        *((a617 + 1)) = s217;
        s218 = spu_sub(spu_mul(a615, t236), spu_mul(a616, t237));
        *((a617 + 8)) = s218;
        s219 = spu_add(spu_mul(a616, t236), spu_mul(a615, t237));
        *((a617 + 9)) = s219;
        t238 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s212, t214);
        t239 = spu_madd(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s213, t215);
        t240 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s212, t214);
        t241 = spu_nmsub(((vector float){0.70710678118654757, 0.70710678118654757, 0.70710678118654757, 0.70710678118654757}), s213, t215);
        a618 = *((a612 + 4));
        a619 = *((a612 + 5));
        a620 = *((a612 + 6));
        a621 = *((a612 + 7));
        s220 = spu_sub(spu_mul(a618, t238), spu_mul(a619, t239));
        *((a617 + 2)) = s220;
        s221 = spu_add(spu_mul(a619, t238), spu_mul(a618, t239));
        *((a617 + 3)) = s221;
        s222 = spu_sub(spu_mul(a620, t240), spu_mul(a621, t241));
        *((a617 + 10)) = s222;
        s223 = spu_add(spu_mul(a621, t240), spu_mul(a620, t241));
        *((a617 + 11)) = s223;
        t242 = spu_sub(t212, t229);
        t243 = spu_add(t213, t228);
        t244 = spu_add(t212, t229);
        t245 = spu_sub(t213, t228);
        a622 = *((a612 + 8));
        a623 = *((a612 + 9));
        a624 = *((a612 + 10));
        a625 = *((a612 + 11));
        s224 = spu_sub(spu_mul(a622, t242), spu_mul(a623, t243));
        *((a617 + 4)) = s224;
        s225 = spu_add(spu_mul(a623, t242), spu_mul(a622, t243));
        *((a617 + 5)) = s225;
        s226 = spu_sub(spu_mul(a624, t244), spu_mul(a625, t245));
        *((a617 + 12)) = s226;
        s227 = spu_add(spu_mul(a625, t244), spu_mul(a624, t245));
        *((a617 + 13)) = s227;
        t246 = spu_madd(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s214, t216);
        t247 = spu_add(t217, s215);
        t248 = spu_nmsub(((vector float){(-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757), (-0.70710678118654757)}), s214, t216);
        t249 = spu_sub(t217, s215);
        a626 = *((a612 + 12));
        a627 = *((a612 + 13));
        a628 = *((a612 + 14));
        a629 = *((a612 + 15));
        s228 = spu_sub(spu_mul(a626, t246), spu_mul(a627, t247));
        *((a617 + 6)) = s228;
        s229 = spu_add(spu_mul(a627, t246), spu_mul(a626, t247));
        *((a617 + 7)) = s229;
        s230 = spu_sub(spu_mul(a628, t248), spu_mul(a629, t249));
        *((a617 + 14)) = s230;
        s231 = spu_add(spu_mul(a629, t248), spu_mul(a628, t249));
        *((a617 + 15)) = s231;
    }
    for(int i5 = 0; i5 <= 7; i5++) {
        vector float  *a1079, *a1080;
        vector float s344, s345, s346, s347, s348, s349, s350
    , s351, s352, s353, s354, s355, s356, s357, s358
    , s359, s360, s361, s362, s363, s364, s365, s366
    , s367, s368, s369, s370, s371, s372, s373, s374
    , s375, s376, s377, s378, s379, s380, s381, s382
    , s383, s384, s385, s387, s388, s389, s390, s391
    , s392, s393, s394, s395, s396, s397, s398, s399
    , s400, s401, s402, s403, s404, s405, s406, s407
    , s408, s409, s410, s411, s412, s413, s414, s415
    , s416, s417, s418, s419, s420, s421, s422, s423
    , s424, s425, s426, s427, s428, s429, s430, s431
    , s432, s433, s434, s435, s436, s437, s438, s439
    , s440, s441, s442, s443, s444, s445, s446, s447
    , s448, s449, s450, s451, s452, s453, s454, s455
    , s456, t659, t660, t661, t662, t663, t664, t665
    , t666, t667, t668, t669, t670, t671, t672, t673
    , t674, t675, t676, t677, t678, t679, t680, t681
    , t682, t683, t684, t685, t686, t687, t688, t689
    , t690, t691, t692, t693, t694;
        a1079 = (((vector float  *) T1) + (2 * i5));
        s344 = *(a1079);
        s345 = *((a1079 + 1));
        s346 = *((a1079 + 16));
        s347 = *((a1079 + 17));
        s348 = *((a1079 + 192));
        s349 = *((a1079 + 193));
        t659 = spu_add(s346, s348);
        t660 = spu_add(s347, s349);
        t661 = spu_sub(s346, s348);
        t662 = spu_sub(s347, s349);
        s350 = *((a1079 + 112));
        s351 = *((a1079 + 113));
        s352 = *((a1079 + 96));
        s353 = *((a1079 + 97));
        t663 = spu_add(s350, s352);
        t664 = spu_add(s351, s353);
        t665 = spu_sub(s350, s352);
        t666 = spu_sub(s351, s353);
        s354 = *((a1079 + 160));
        s355 = *((a1079 + 161));
        s356 = *((a1079 + 48));
        s357 = *((a1079 + 49));
        t667 = spu_add(s354, s356);
        t668 = spu_add(s355, s357);
        t669 = spu_sub(s354, s356);
        t670 = spu_sub(s355, s357);
        s358 = *((a1079 + 80));
        s359 = *((a1079 + 81));
        s360 = *((a1079 + 128));
        s361 = *((a1079 + 129));
        t671 = spu_add(s358, s360);
        t672 = spu_add(s359, s361);
        t673 = spu_sub(s358, s360);
        t674 = spu_sub(s359, s361);
        s362 = *((a1079 + 144));
        s363 = *((a1079 + 145));
        s364 = *((a1079 + 64));
        s365 = *((a1079 + 65));
        t675 = spu_add(s362, s364);
        t676 = spu_add(s363, s365);
        t677 = spu_sub(s362, s364);
        t678 = spu_sub(s363, s365);
        s366 = *((a1079 + 176));
        s367 = *((a1079 + 177));
        s368 = *((a1079 + 32));
        s369 = *((a1079 + 33));
        t679 = spu_add(s366, s368);
        t680 = spu_add(s367, s369);
        t681 = spu_sub(s366, s368);
        t682 = spu_sub(s367, s369);
        t683 = spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t679, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t675, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t671, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t667, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t663, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t659, s344))))));
        t684 = spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t680, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t676, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t672, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t668, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t664, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t660, s345))))));
        t685 = spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t679, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t675, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t671, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t667, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t663, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t659, s344))))));
        t686 = spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t680, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t676, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t672, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t668, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t664, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t660, s345))))));
        t687 = spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t679, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t675, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t671, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t667, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t663, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t659, s344))))));
        t688 = spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t680, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t676, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t672, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t668, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t664, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t660, s345))))));
        t689 = spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t679, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t675, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t671, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t667, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t663, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t659, s344))))));
        t690 = spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t680, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t676, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t672, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t668, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t664, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t660, s345))))));
        t691 = spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t679, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t675, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t671, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t667, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t663, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t659, s344))))));
        t692 = spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t680, spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t676, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t672, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t668, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t664, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t660, s345))))));
        t693 = spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t679, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t675, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t671, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t667, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t663, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t659, s344))))));
        t694 = spu_madd(((vector float){0.88545602565320991,0.88545602565320991,0.88545602565320991,0.88545602565320991}), t680, spu_madd(((vector float){0.56806474673115581,0.56806474673115581,0.56806474673115581,0.56806474673115581}), t676, spu_nmsub(((vector float){0.35460488704253562,0.35460488704253562,0.35460488704253562,0.35460488704253562}), t672, spu_nmsub(((vector float){0.74851074817110108,0.74851074817110108,0.74851074817110108,0.74851074817110108}), t668, spu_madd(((vector float){0.12053668025532305,0.12053668025532305,0.12053668025532305,0.12053668025532305}), t664, spu_nmsub(((vector float){0.97094181742605201,0.97094181742605201,0.97094181742605201,0.97094181742605201}), t660, s345))))));
        s370 = spu_nmsub(((vector float){1.941883634852104,1.941883634852104,1.941883634852104,1.941883634852104}), t662, t666);
        s371 = spu_madd(((vector float){4.1481149052793773,4.1481149052793773,4.1481149052793773,4.1481149052793773}), t670, s370);
        s372 = spu_nmsub(((vector float){2.7709120513064196,2.7709120513064196,2.7709120513064196,2.7709120513064196}), t674, s371);
        s373 = spu_madd(((vector float){3.9070415447687314,3.9070415447687314,3.9070415447687314,3.9070415447687314}), t678, s372);
        s374 = spu_madd(((vector float){3.4389051311943062,3.4389051311943062,3.4389051311943062,3.4389051311943062}), t682, s373);
        s375 = spu_nmsub(((vector float){0.51496391547486364,0.51496391547486364,0.51496391547486364,0.51496391547486364}), t665, t661);
        s376 = spu_nmsub(((vector float){2.1361294934623114,2.1361294934623114,2.1361294934623114,2.1361294934623114}), t669, s375);
        s377 = spu_madd(((vector float){1.4269197193772403,1.4269197193772403,1.4269197193772403,1.4269197193772403}), t673, s376);
        s378 = spu_nmsub(((vector float){2.0119854118170659,2.0119854118170659,2.0119854118170659,2.0119854118170659}), t677, s377);
        s379 = spu_nmsub(((vector float){1.7709120513064196,1.7709120513064196,1.7709120513064196,1.7709120513064196}), t681, s378);
        s380 = spu_madd(((vector float){0.56468078087914642,0.56468078087914642,0.56468078087914642,0.56468078087914642}), t666, t662);
        s381 = spu_nmsub(((vector float){3.4389051311943062,3.4389051311943062,3.4389051311943062,3.4389051311943062}), s380, t670);
        s382 = spu_madd(((vector float){4.1481149052793773,4.1481149052793773,4.1481149052793773,4.1481149052793773}), t674, s381);
        s383 = spu_nmsub(((vector float){2.7709120513064196,2.7709120513064196,2.7709120513064196,2.7709120513064196}), t678, s382);
        s384 = spu_madd(((vector float){3.9070415447687314,3.9070415447687314,3.9070415447687314,3.9070415447687314}), t682, s383);
        s385 = spu_madd(((vector float){0.56468078087914642,0.56468078087914642,0.56468078087914642,0.56468078087914642}), t665, t661);
        s387 = spu_nmsub(((vector float){0.29079022591492876,0.29079022591492876,0.29079022591492876,0.29079022591492876}), t669, s385);
        s388 = spu_nmsub(((vector float){1.2062312704272735,1.2062312704272735,1.2062312704272735,1.2062312704272735}), t673, s387);
        s389 = spu_madd(((vector float){0.80575414138979251,0.80575414138979251,0.80575414138979251,0.80575414138979251}), t677, s388);
        s390 = spu_nmsub(((vector float){1.1361294934623116,1.1361294934623116,1.1361294934623116,1.1361294934623116}), t681, s389);
        s391 = spu_madd(((vector float){0.88018135763075545,0.88018135763075545,0.88018135763075545,0.88018135763075545}), t666, t662);
        s392 = spu_madd(((vector float){0.49702149634220222,0.49702149634220222,0.49702149634220222,0.49702149634220222}), t670, s391);
        s393 = spu_nmsub(((vector float){3.9070415447687314,3.9070415447687314,3.9070415447687314,3.9070415447687314}), s392, t674);
        s394 = spu_madd(((vector float){4.1481149052793773,4.1481149052793773,4.1481149052793773,4.1481149052793773}), t678, s393);
        s395 = spu_nmsub(((vector float){2.7709120513064196,2.7709120513064196,2.7709120513064196,2.7709120513064196}), t682, s394);
        s396 = spu_madd(((vector float){0.88018135763075545,0.88018135763075545,0.88018135763075545,0.88018135763075545}), t665, t661);
        s397 = spu_madd(((vector float){0.49702149634220222,0.49702149634220222,0.49702149634220222,0.49702149634220222}), t669, s396);
        s398 = spu_nmsub(((vector float){0.25594813583155607,0.25594813583155607,0.25594813583155607,0.25594813583155607}), t673, s397);
        s399 = spu_nmsub(((vector float){1.0617022772213485,1.0617022772213485,1.0617022772213485,1.0617022772213485}), t677, s398);
        s400 = spu_madd(((vector float){0.70920977408507124,0.70920977408507124,0.70920977408507124,0.70920977408507124}), t681, s399);
        s401 = spu_nmsub(((vector float){1.4100200484265293,1.4100200484265293,1.4100200484265293,1.4100200484265293}), t666, t662);
        s402 = spu_nmsub(((vector float){1.2410733605106461,1.2410733605106461,1.2410733605106461,1.2410733605106461}), t670, s401);
        s403 = spu_nmsub(((vector float){0.70081027434145793,0.70081027434145793,0.70081027434145793,0.70081027434145793}), t674, s402);
        s404 = spu_madd(((vector float){0.36089200287989059,0.36089200287989059,0.36089200287989059,0.36089200287989059}), t678, s403);
        s405 = spu_madd(((vector float){1.4970214963422022,1.4970214963422022,1.4970214963422022,1.4970214963422022}), t682, s404);
        s406 = spu_nmsub(((vector float){0.70920977408507124,0.70920977408507124,0.70920977408507124,0.70920977408507124}), t661, t665);
        s407 = spu_madd(((vector float){0.88018135763075545,0.88018135763075545,0.88018135763075545,0.88018135763075545}), t669, s406);
        s408 = spu_madd(((vector float){0.49702149634220222,0.49702149634220222,0.49702149634220222,0.49702149634220222}), t673, s407);
        s409 = spu_nmsub(((vector float){0.25594813583155607,0.25594813583155607,0.25594813583155607,0.25594813583155607}), t677, s408);
        s410 = spu_nmsub(((vector float){1.0617022772213485,1.0617022772213485,1.0617022772213485,1.0617022772213485}), t681, s409);
        s411 = spu_nmsub(((vector float){1.4970214963422022,1.4970214963422022,1.4970214963422022,1.4970214963422022}), t662, t666);
        s412 = spu_nmsub(((vector float){1.4100200484265293,1.4100200484265293,1.4100200484265293,1.4100200484265293}), t670, s411);
        s413 = spu_nmsub(((vector float){1.2410733605106461,1.2410733605106461,1.2410733605106461,1.2410733605106461}), t674, s412);
        s414 = spu_nmsub(((vector float){0.70081027434145793,0.70081027434145793,0.70081027434145793,0.70081027434145793}), t678, s413);
        s415 = spu_madd(((vector float){0.36089200287989059,0.36089200287989059,0.36089200287989059,0.36089200287989059}), t682, s414);
        s416 = spu_nmsub(((vector float){0.66799307988788648,0.66799307988788648,0.66799307988788648,0.66799307988788648}), t665, t661);
        s417 = spu_madd(((vector float){0.94188363485210413,0.94188363485210413,0.94188363485210413,0.94188363485210413}), t669, s416);
        s418 = spu_madd(((vector float){0.82902841645431569,0.82902841645431569,0.82902841645431569,0.82902841645431569}), t673, s417);
        s419 = spu_madd(((vector float){0.46813641357442515,0.46813641357442515,0.46813641357442515,0.46813641357442515}), t677, s418);
        s420 = spu_nmsub(((vector float){0.24107336051064612,0.24107336051064612,0.24107336051064612,0.24107336051064612}), t681, s419);
        s421 = spu_madd(((vector float){4.1481149052793773,4.1481149052793773,4.1481149052793773,4.1481149052793773}), t666, t662);
        s422 = spu_nmsub(((vector float){0.36089200287989059,0.36089200287989059,0.36089200287989059,0.36089200287989059}), s421, t670);
        s423 = spu_nmsub(((vector float){1.4100200484265293,1.4100200484265293,1.4100200484265293,1.4100200484265293}), t674, s422);
        s424 = spu_nmsub(((vector float){1.2410733605106461,1.2410733605106461,1.2410733605106461,1.2410733605106461}), t678, s423);
        s425 = spu_nmsub(((vector float){0.70081027434145793,0.70081027434145793,0.70081027434145793,0.70081027434145793}), t682, s424);
        s426 = spu_madd(((vector float){4.1481149052793773,4.1481149052793773,4.1481149052793773,4.1481149052793773}), t665, t661);
        s427 = spu_nmsub(((vector float){2.7709120513064196,2.7709120513064196,2.7709120513064196,2.7709120513064196}), t669, s426);
        s428 = spu_madd(((vector float){3.9070415447687314,3.9070415447687314,3.9070415447687314,3.9070415447687314}), t673, s427);
        s429 = spu_madd(((vector float){3.4389051311943062,3.4389051311943062,3.4389051311943062,3.4389051311943062}), t677, s428);
        s430 = spu_madd(((vector float){1.941883634852104,1.941883634852104,1.941883634852104,1.941883634852104}), t681, s429);
        a1080 = (((vector float  *) Y) + i5);
        s431 = spu_add(s344, spu_add(t659, spu_add(t663, spu_add(t667, spu_add(t671, spu_add(t675, t679))))));
        *(a1080) = s431;
        s432 = spu_add(s345, spu_add(t660, spu_add(t664, spu_add(t668, spu_add(t672, spu_add(t676, t680))))));
        *((a1080 + 104)) = s432;
        s433 = spu_madd(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s374, t683);
        *((a1080 + 8)) = s433;
        s434 = spu_madd(((vector float){0.46472317204376856,0.46472317204376856,0.46472317204376856,0.46472317204376856}), s379, t684);
        *((a1080 + 112)) = s434;
        s435 = spu_nmsub(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s374, t683);
        *((a1080 + 96)) = s435;
        s436 = spu_nmsub(((vector float){0.46472317204376856,0.46472317204376856,0.46472317204376856,0.46472317204376856}), s379, t684);
        *((a1080 + 200)) = s436;
        s437 = spu_madd(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s384, t685);
        *((a1080 + 16)) = s437;
        s438 = spu_madd(((vector float){0.82298386589365635,0.82298386589365635,0.82298386589365635,0.82298386589365635}), s390, t686);
        *((a1080 + 120)) = s438;
        s439 = spu_nmsub(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s384, t685);
        *((a1080 + 88)) = s439;
        s440 = spu_nmsub(((vector float){0.82298386589365635,0.82298386589365635,0.82298386589365635,0.82298386589365635}), s390, t686);
        *((a1080 + 192)) = s440;
        s441 = spu_madd(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s395, t687);
        *((a1080 + 32)) = s441;
        s442 = spu_madd(((vector float){0.93501624268541483,0.93501624268541483,0.93501624268541483,0.93501624268541483}), s400, t688);
        *((a1080 + 136)) = s442;
        s443 = spu_nmsub(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s395, t687);
        *((a1080 + 72)) = s443;
        s444 = spu_nmsub(((vector float){0.93501624268541483,0.93501624268541483,0.93501624268541483,0.93501624268541483}), s400, t688);
        *((a1080 + 176)) = s444;
        s445 = spu_madd(((vector float){0.66312265824079519,0.66312265824079519,0.66312265824079519,0.66312265824079519}), s405, t689);
        *((a1080 + 64)) = s445;
        s446 = spu_madd(((vector float){0.93501624268541483,0.93501624268541483,0.93501624268541483,0.93501624268541483}), s410, t690);
        *((a1080 + 168)) = s446;
        s447 = spu_nmsub(((vector float){0.66312265824079519,0.66312265824079519,0.66312265824079519,0.66312265824079519}), s405, t689);
        *((a1080 + 40)) = s447;
        s448 = spu_nmsub(((vector float){0.93501624268541483,0.93501624268541483,0.93501624268541483,0.93501624268541483}), s410, t690);
        *((a1080 + 144)) = s448;
        s449 = spu_madd(((vector float){0.66312265824079519,0.66312265824079519,0.66312265824079519,0.66312265824079519}), s415, t691);
        *((a1080 + 24)) = s449;
        s450 = spu_madd(((vector float){0.99270887409805397,0.99270887409805397,0.99270887409805397,0.99270887409805397}), s420, t692);
        *((a1080 + 128)) = s450;
        s451 = spu_nmsub(((vector float){0.66312265824079519,0.66312265824079519,0.66312265824079519,0.66312265824079519}), s415, t691);
        *((a1080 + 80)) = s451;
        s452 = spu_nmsub(((vector float){0.99270887409805397,0.99270887409805397,0.99270887409805397,0.99270887409805397}), s420, t692);
        *((a1080 + 184)) = s452;
        s453 = spu_madd(((vector float){0.66312265824079519,0.66312265824079519,0.66312265824079519,0.66312265824079519}), s425, t693);
        *((a1080 + 48)) = s453;
        s454 = spu_madd(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s430, t694);
        *((a1080 + 152)) = s454;
        s455 = spu_nmsub(((vector float){0.66312265824079519,0.66312265824079519,0.66312265824079519,0.66312265824079519}), s425, t693);
        *((a1080 + 56)) = s455;
        s456 = spu_nmsub(((vector float){0.23931566428755777,0.23931566428755777,0.23931566428755777,0.23931566428755777}), s430, t694);
        *((a1080 + 160)) = s456;
    }
}
